/*
 * This file is autogenerated with bcop:
 * The Compiz option code generator
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 */

#ifndef _ANAGLYPH_OPTIONS_H
#define _ANAGLYPH_OPTIONS_H

#include <compiz-common.h>

COMPIZ_BEGIN_DECLS

CompPluginVTable * getCompPluginInfo (void);

typedef enum
{
    AnaglyphDisplayOptionWindowToggleKey,
    AnaglyphDisplayOptionScreenToggleKey,
    AnaglyphDisplayOptionWindowToggleButton,
    AnaglyphDisplayOptionScreenToggleButton,
    AnaglyphDisplayOptionNum
} AnaglyphDisplayOptions;

typedef void (*anaglyphDisplayOptionChangeNotifyProc) (CompDisplay *display, CompOption *opt, AnaglyphDisplayOptions num);

CompOption *anaglyphGetDisplayOption (CompDisplay *d, AnaglyphDisplayOptions num);

typedef enum
{
    AnaglyphScreenOptionAnaglyphMatch,
    AnaglyphScreenOptionExcludeMatch,
    AnaglyphScreenOptionOffset,
    AnaglyphScreenOptionDesktopOffset,
    AnaglyphScreenOptionDesaturate,
    AnaglyphScreenOptionMipmaps,
    AnaglyphScreenOptionNum
} AnaglyphScreenOptions;

typedef void (*anaglyphScreenOptionChangeNotifyProc) (CompScreen *screen, CompOption *opt, AnaglyphScreenOptions num);

CompOption *anaglyphGetScreenOption (CompScreen *s, AnaglyphScreenOptions num);

CompAction *     anaglyphGetWindowToggleKey (CompDisplay *d);
void             anaglyphSetWindowToggleKeyInitiate (CompDisplay *d, CompActionCallBackProc init);
void             anaglyphSetWindowToggleKeyTerminate (CompDisplay *d, CompActionCallBackProc term);
CompOption *     anaglyphGetWindowToggleKeyOption (CompDisplay *d);
void             anaglyphSetWindowToggleKeyNotify (CompDisplay *d, anaglyphDisplayOptionChangeNotifyProc notify);

CompAction *     anaglyphGetScreenToggleKey (CompDisplay *d);
void             anaglyphSetScreenToggleKeyInitiate (CompDisplay *d, CompActionCallBackProc init);
void             anaglyphSetScreenToggleKeyTerminate (CompDisplay *d, CompActionCallBackProc term);
CompOption *     anaglyphGetScreenToggleKeyOption (CompDisplay *d);
void             anaglyphSetScreenToggleKeyNotify (CompDisplay *d, anaglyphDisplayOptionChangeNotifyProc notify);

CompAction *     anaglyphGetWindowToggleButton (CompDisplay *d);
void             anaglyphSetWindowToggleButtonInitiate (CompDisplay *d, CompActionCallBackProc init);
void             anaglyphSetWindowToggleButtonTerminate (CompDisplay *d, CompActionCallBackProc term);
CompOption *     anaglyphGetWindowToggleButtonOption (CompDisplay *d);
void             anaglyphSetWindowToggleButtonNotify (CompDisplay *d, anaglyphDisplayOptionChangeNotifyProc notify);

CompAction *     anaglyphGetScreenToggleButton (CompDisplay *d);
void             anaglyphSetScreenToggleButtonInitiate (CompDisplay *d, CompActionCallBackProc init);
void             anaglyphSetScreenToggleButtonTerminate (CompDisplay *d, CompActionCallBackProc term);
CompOption *     anaglyphGetScreenToggleButtonOption (CompDisplay *d);
void             anaglyphSetScreenToggleButtonNotify (CompDisplay *d, anaglyphDisplayOptionChangeNotifyProc notify);

CompMatch *      anaglyphGetAnaglyphMatch (CompScreen *s);
CompOption *     anaglyphGetAnaglyphMatchOption (CompScreen *s);
void             anaglyphSetAnaglyphMatchNotify (CompScreen *s, anaglyphScreenOptionChangeNotifyProc notify);

CompMatch *      anaglyphGetExcludeMatch (CompScreen *s);
CompOption *     anaglyphGetExcludeMatchOption (CompScreen *s);
void             anaglyphSetExcludeMatchNotify (CompScreen *s, anaglyphScreenOptionChangeNotifyProc notify);

float            anaglyphGetOffset (CompScreen *s);
CompOption *     anaglyphGetOffsetOption (CompScreen *s);
void             anaglyphSetOffsetNotify (CompScreen *s, anaglyphScreenOptionChangeNotifyProc notify);

float            anaglyphGetDesktopOffset (CompScreen *s);
CompOption *     anaglyphGetDesktopOffsetOption (CompScreen *s);
void             anaglyphSetDesktopOffsetNotify (CompScreen *s, anaglyphScreenOptionChangeNotifyProc notify);

Bool             anaglyphGetDesaturate (CompScreen *s);
CompOption *     anaglyphGetDesaturateOption (CompScreen *s);
void             anaglyphSetDesaturateNotify (CompScreen *s, anaglyphScreenOptionChangeNotifyProc notify);

Bool             anaglyphGetMipmaps (CompScreen *s);
CompOption *     anaglyphGetMipmapsOption (CompScreen *s);
void             anaglyphSetMipmapsNotify (CompScreen *s, anaglyphScreenOptionChangeNotifyProc notify);

#ifndef GENERIC_PRIVATE_DEFINES
#define GENERIC_PRIVATE_DEFINES

#define GET_PLUGIN_CORE(object, plugin) \
    ((plugin##Core *) (object)->base.privates[plugin##CorePrivateIndex].ptr)
#define PLUGIN_CORE(object, plugin, prefix) \
    plugin##Core * prefix##c = GET_PLUGIN_CORE (object, plugin)

#define GET_PLUGIN_DISPLAY(object, plugin) \
    ((plugin##Display *) \
	(object)->base.privates[plugin##DisplayPrivateIndex].ptr)
#define PLUGIN_DISPLAY(object, plugin, prefix) \
    plugin##Display * prefix##d = GET_PLUGIN_DISPLAY (object, plugin)

#define GET_PLUGIN_SCREEN(object, parent, plugin) \
    ((plugin##Screen *) \
	(object)->base.privates[(parent)->screenPrivateIndex].ptr)
#define PLUGIN_SCREEN(object, plugin, prefix) \
    plugin##Screen * prefix##s = \
	GET_PLUGIN_SCREEN (object, \
	GET_PLUGIN_DISPLAY ((object)->display, plugin), plugin)

#define GET_PLUGIN_WINDOW(object, parent, plugin) \
    ((plugin##Window *) \
	(object)->base.privates[(parent)->windowPrivateIndex].ptr)
#define PLUGIN_WINDOW(object, plugin, prefix) \
    plugin##Window * prefix##w = \
	GET_PLUGIN_WINDOW  (object, \
	GET_PLUGIN_SCREEN  ((object)->screen, \
	GET_PLUGIN_DISPLAY ((object)->screen->display, plugin), plugin), plugin)

#endif

COMPIZ_END_DECLS

#endif
