/*
 * This file is autogenerated with bcop:
 * The Compiz option code generator
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 */

#ifndef _ATLANTIS_OPTIONS_H
#define _ATLANTIS_OPTIONS_H

#include <compiz-common.h>

COMPIZ_BEGIN_DECLS

CompPluginVTable * getCompPluginInfo (void);

typedef enum
{
    AtlantisDisplayOptionNum
} AtlantisDisplayOptions;

typedef void (*atlantisDisplayOptionChangeNotifyProc) (CompDisplay *display, CompOption *opt, AtlantisDisplayOptions num);

CompOption *atlantisGetDisplayOption (CompDisplay *d, AtlantisDisplayOptions num);

typedef enum
{
    AtlantisScreenOptionSpeedFactor,
    AtlantisScreenOptionStartCrabsBottom,
    AtlantisScreenOptionSchoolSimilarGroups,
    AtlantisScreenOptionLowPoly,
    AtlantisScreenOptionCreatureType,
    AtlantisScreenOptionCreatureColor,
    AtlantisScreenOptionCreatureNumber,
    AtlantisScreenOptionCreatureSize,
    AtlantisScreenOptionPlantType,
    AtlantisScreenOptionPlantColor,
    AtlantisScreenOptionPlantNumber,
    AtlantisScreenOptionPlantSize,
    AtlantisScreenOptionShowWater,
    AtlantisScreenOptionShowWaterWire,
    AtlantisScreenOptionShowGround,
    AtlantisScreenOptionGroundColor,
    AtlantisScreenOptionWaterHeight,
    AtlantisScreenOptionWaterColor,
    AtlantisScreenOptionGridQuality,
    AtlantisScreenOptionRenderWaves,
    AtlantisScreenOptionWaveRipple,
    AtlantisScreenOptionWaveAmplitude,
    AtlantisScreenOptionWaveFrequency,
    AtlantisScreenOptionSmallWaveAmplitude,
    AtlantisScreenOptionSmallWaveFrequency,
    AtlantisScreenOptionRescaleWidth,
    AtlantisScreenOptionRotateLighting,
    AtlantisScreenOptionLightInclination,
    AtlantisScreenOptionLightAmbient,
    AtlantisScreenOptionNum
} AtlantisScreenOptions;

typedef void (*atlantisScreenOptionChangeNotifyProc) (CompScreen *screen, CompOption *opt, AtlantisScreenOptions num);

CompOption *atlantisGetScreenOption (CompScreen *s, AtlantisScreenOptions num);

typedef enum
{
    CreatureTypeFishButterflyfish = 0,
    CreatureTypeFishChromis1 = 1,
    CreatureTypeFishChromis2 = 2,
    CreatureTypeFishChromis3 = 3,
    CreatureTypeFishType1 = 4,
    CreatureTypeFishType2 = 5,
    CreatureTypeDolphin = 6,
    CreatureTypeShark = 7,
    CreatureTypeWhale = 8,
    CreatureTypeCrab = 9,
} AtlantisCreatureTypeEnum;

typedef enum
{
    PlantTypeCoral1 = 0,
    PlantTypeCoral2 = 1,
    PlantTypeAerator = 2,
} AtlantisPlantTypeEnum;

#define CreatureTypeFishButterflyfishMask (1 << 0)
#define CreatureTypeFishChromis1Mask (1 << 1)
#define CreatureTypeFishChromis2Mask (1 << 2)
#define CreatureTypeFishChromis3Mask (1 << 3)
#define CreatureTypeFishType1Mask (1 << 4)
#define CreatureTypeFishType2Mask (1 << 5)
#define CreatureTypeDolphinMask (1 << 6)
#define CreatureTypeSharkMask (1 << 7)
#define CreatureTypeWhaleMask (1 << 8)
#define CreatureTypeCrabMask (1 << 9)


#define PlantTypeCoral1Mask (1 << 0)
#define PlantTypeCoral2Mask (1 << 1)
#define PlantTypeAeratorMask (1 << 2)


float            atlantisGetSpeedFactor (CompScreen *s);
CompOption *     atlantisGetSpeedFactorOption (CompScreen *s);
void             atlantisSetSpeedFactorNotify (CompScreen *s, atlantisScreenOptionChangeNotifyProc notify);

Bool             atlantisGetStartCrabsBottom (CompScreen *s);
CompOption *     atlantisGetStartCrabsBottomOption (CompScreen *s);
void             atlantisSetStartCrabsBottomNotify (CompScreen *s, atlantisScreenOptionChangeNotifyProc notify);

Bool             atlantisGetSchoolSimilarGroups (CompScreen *s);
CompOption *     atlantisGetSchoolSimilarGroupsOption (CompScreen *s);
void             atlantisSetSchoolSimilarGroupsNotify (CompScreen *s, atlantisScreenOptionChangeNotifyProc notify);

Bool             atlantisGetLowPoly (CompScreen *s);
CompOption *     atlantisGetLowPolyOption (CompScreen *s);
void             atlantisSetLowPolyNotify (CompScreen *s, atlantisScreenOptionChangeNotifyProc notify);

CompListValue *  atlantisGetCreatureType (CompScreen *s);
unsigned int     atlantisGetCreatureTypeMask (CompScreen *s);
CompOption *     atlantisGetCreatureTypeOption (CompScreen *s);
void             atlantisSetCreatureTypeNotify (CompScreen *s, atlantisScreenOptionChangeNotifyProc notify);

CompListValue *  atlantisGetCreatureColor (CompScreen *s);
CompOption *     atlantisGetCreatureColorOption (CompScreen *s);
void             atlantisSetCreatureColorNotify (CompScreen *s, atlantisScreenOptionChangeNotifyProc notify);

CompListValue *  atlantisGetCreatureNumber (CompScreen *s);
CompOption *     atlantisGetCreatureNumberOption (CompScreen *s);
void             atlantisSetCreatureNumberNotify (CompScreen *s, atlantisScreenOptionChangeNotifyProc notify);

CompListValue *  atlantisGetCreatureSize (CompScreen *s);
CompOption *     atlantisGetCreatureSizeOption (CompScreen *s);
void             atlantisSetCreatureSizeNotify (CompScreen *s, atlantisScreenOptionChangeNotifyProc notify);

CompListValue *  atlantisGetPlantType (CompScreen *s);
unsigned int     atlantisGetPlantTypeMask (CompScreen *s);
CompOption *     atlantisGetPlantTypeOption (CompScreen *s);
void             atlantisSetPlantTypeNotify (CompScreen *s, atlantisScreenOptionChangeNotifyProc notify);

CompListValue *  atlantisGetPlantColor (CompScreen *s);
CompOption *     atlantisGetPlantColorOption (CompScreen *s);
void             atlantisSetPlantColorNotify (CompScreen *s, atlantisScreenOptionChangeNotifyProc notify);

CompListValue *  atlantisGetPlantNumber (CompScreen *s);
CompOption *     atlantisGetPlantNumberOption (CompScreen *s);
void             atlantisSetPlantNumberNotify (CompScreen *s, atlantisScreenOptionChangeNotifyProc notify);

CompListValue *  atlantisGetPlantSize (CompScreen *s);
CompOption *     atlantisGetPlantSizeOption (CompScreen *s);
void             atlantisSetPlantSizeNotify (CompScreen *s, atlantisScreenOptionChangeNotifyProc notify);

Bool             atlantisGetShowWater (CompScreen *s);
CompOption *     atlantisGetShowWaterOption (CompScreen *s);
void             atlantisSetShowWaterNotify (CompScreen *s, atlantisScreenOptionChangeNotifyProc notify);

Bool             atlantisGetShowWaterWire (CompScreen *s);
CompOption *     atlantisGetShowWaterWireOption (CompScreen *s);
void             atlantisSetShowWaterWireNotify (CompScreen *s, atlantisScreenOptionChangeNotifyProc notify);

Bool             atlantisGetShowGround (CompScreen *s);
CompOption *     atlantisGetShowGroundOption (CompScreen *s);
void             atlantisSetShowGroundNotify (CompScreen *s, atlantisScreenOptionChangeNotifyProc notify);

unsigned short * atlantisGetGroundColor (CompScreen *s);
unsigned short   atlantisGetGroundColorRed (CompScreen *s);
unsigned short   atlantisGetGroundColorGreen (CompScreen *s);
unsigned short   atlantisGetGroundColorBlue (CompScreen *s);
unsigned short   atlantisGetGroundColorAlpha (CompScreen *s);
CompOption *     atlantisGetGroundColorOption (CompScreen *s);
void             atlantisSetGroundColorNotify (CompScreen *s, atlantisScreenOptionChangeNotifyProc notify);

float            atlantisGetWaterHeight (CompScreen *s);
CompOption *     atlantisGetWaterHeightOption (CompScreen *s);
void             atlantisSetWaterHeightNotify (CompScreen *s, atlantisScreenOptionChangeNotifyProc notify);

unsigned short * atlantisGetWaterColor (CompScreen *s);
unsigned short   atlantisGetWaterColorRed (CompScreen *s);
unsigned short   atlantisGetWaterColorGreen (CompScreen *s);
unsigned short   atlantisGetWaterColorBlue (CompScreen *s);
unsigned short   atlantisGetWaterColorAlpha (CompScreen *s);
CompOption *     atlantisGetWaterColorOption (CompScreen *s);
void             atlantisSetWaterColorNotify (CompScreen *s, atlantisScreenOptionChangeNotifyProc notify);

int              atlantisGetGridQuality (CompScreen *s);
CompOption *     atlantisGetGridQualityOption (CompScreen *s);
void             atlantisSetGridQualityNotify (CompScreen *s, atlantisScreenOptionChangeNotifyProc notify);

Bool             atlantisGetRenderWaves (CompScreen *s);
CompOption *     atlantisGetRenderWavesOption (CompScreen *s);
void             atlantisSetRenderWavesNotify (CompScreen *s, atlantisScreenOptionChangeNotifyProc notify);

Bool             atlantisGetWaveRipple (CompScreen *s);
CompOption *     atlantisGetWaveRippleOption (CompScreen *s);
void             atlantisSetWaveRippleNotify (CompScreen *s, atlantisScreenOptionChangeNotifyProc notify);

float            atlantisGetWaveAmplitude (CompScreen *s);
CompOption *     atlantisGetWaveAmplitudeOption (CompScreen *s);
void             atlantisSetWaveAmplitudeNotify (CompScreen *s, atlantisScreenOptionChangeNotifyProc notify);

float            atlantisGetWaveFrequency (CompScreen *s);
CompOption *     atlantisGetWaveFrequencyOption (CompScreen *s);
void             atlantisSetWaveFrequencyNotify (CompScreen *s, atlantisScreenOptionChangeNotifyProc notify);

float            atlantisGetSmallWaveAmplitude (CompScreen *s);
CompOption *     atlantisGetSmallWaveAmplitudeOption (CompScreen *s);
void             atlantisSetSmallWaveAmplitudeNotify (CompScreen *s, atlantisScreenOptionChangeNotifyProc notify);

float            atlantisGetSmallWaveFrequency (CompScreen *s);
CompOption *     atlantisGetSmallWaveFrequencyOption (CompScreen *s);
void             atlantisSetSmallWaveFrequencyNotify (CompScreen *s, atlantisScreenOptionChangeNotifyProc notify);

Bool             atlantisGetRescaleWidth (CompScreen *s);
CompOption *     atlantisGetRescaleWidthOption (CompScreen *s);
void             atlantisSetRescaleWidthNotify (CompScreen *s, atlantisScreenOptionChangeNotifyProc notify);

Bool             atlantisGetRotateLighting (CompScreen *s);
CompOption *     atlantisGetRotateLightingOption (CompScreen *s);
void             atlantisSetRotateLightingNotify (CompScreen *s, atlantisScreenOptionChangeNotifyProc notify);

float            atlantisGetLightInclination (CompScreen *s);
CompOption *     atlantisGetLightInclinationOption (CompScreen *s);
void             atlantisSetLightInclinationNotify (CompScreen *s, atlantisScreenOptionChangeNotifyProc notify);

float            atlantisGetLightAmbient (CompScreen *s);
CompOption *     atlantisGetLightAmbientOption (CompScreen *s);
void             atlantisSetLightAmbientNotify (CompScreen *s, atlantisScreenOptionChangeNotifyProc notify);

#ifndef GENERIC_PRIVATE_DEFINES
#define GENERIC_PRIVATE_DEFINES

#define GET_PLUGIN_CORE(object, plugin) \
    ((plugin##Core *) (object)->base.privates[plugin##CorePrivateIndex].ptr)
#define PLUGIN_CORE(object, plugin, prefix) \
    plugin##Core * prefix##c = GET_PLUGIN_CORE (object, plugin)

#define GET_PLUGIN_DISPLAY(object, plugin) \
    ((plugin##Display *) \
	(object)->base.privates[plugin##DisplayPrivateIndex].ptr)
#define PLUGIN_DISPLAY(object, plugin, prefix) \
    plugin##Display * prefix##d = GET_PLUGIN_DISPLAY (object, plugin)

#define GET_PLUGIN_SCREEN(object, parent, plugin) \
    ((plugin##Screen *) \
	(object)->base.privates[(parent)->screenPrivateIndex].ptr)
#define PLUGIN_SCREEN(object, plugin, prefix) \
    plugin##Screen * prefix##s = \
	GET_PLUGIN_SCREEN (object, \
	GET_PLUGIN_DISPLAY ((object)->display, plugin), plugin)

#define GET_PLUGIN_WINDOW(object, parent, plugin) \
    ((plugin##Window *) \
	(object)->base.privates[(parent)->windowPrivateIndex].ptr)
#define PLUGIN_WINDOW(object, plugin, prefix) \
    plugin##Window * prefix##w = \
	GET_PLUGIN_WINDOW  (object, \
	GET_PLUGIN_SCREEN  ((object)->screen, \
	GET_PLUGIN_DISPLAY ((object)->screen->display, plugin), plugin), plugin)

#endif

COMPIZ_END_DECLS

#endif
