/*
 * This file is autogenerated with bcop:
 * The Compiz option code generator
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 */

#ifndef _CUBEMODEL_OPTIONS_H
#define _CUBEMODEL_OPTIONS_H

#include <compiz-common.h>

COMPIZ_BEGIN_DECLS

CompPluginVTable * getCompPluginInfo (void);

typedef enum
{
    CubemodelDisplayOptionNum
} CubemodelDisplayOptions;

typedef void (*cubemodelDisplayOptionChangeNotifyProc) (CompDisplay *display, CompOption *opt, CubemodelDisplayOptions num);

CompOption *cubemodelGetDisplayOption (CompDisplay *d, CubemodelDisplayOptions num);

typedef enum
{
    CubemodelScreenOptionGlobalModelScaleFactor,
    CubemodelScreenOptionModelFilename,
    CubemodelScreenOptionModelScaleFactor,
    CubemodelScreenOptionModelXOffset,
    CubemodelScreenOptionModelYOffset,
    CubemodelScreenOptionModelZOffset,
    CubemodelScreenOptionModelRotationPlane,
    CubemodelScreenOptionModelRotationRate,
    CubemodelScreenOptionModelAnimation,
    CubemodelScreenOptionModelFps,
    CubemodelScreenOptionRescaleWidth,
    CubemodelScreenOptionRenderFrontAndBack,
    CubemodelScreenOptionRotateLighting,
    CubemodelScreenOptionLightInclination,
    CubemodelScreenOptionLightAmbient,
    CubemodelScreenOptionLightDiffuse,
    CubemodelScreenOptionLightSpecular,
    CubemodelScreenOptionConcurrentLoad,
    CubemodelScreenOptionNum
} CubemodelScreenOptions;

typedef void (*cubemodelScreenOptionChangeNotifyProc) (CompScreen *screen, CompOption *opt, CubemodelScreenOptions num);

CompOption *cubemodelGetScreenOption (CompScreen *s, CubemodelScreenOptions num);

typedef enum
{
    ModelRotationPlaneXy = 0,
    ModelRotationPlaneYz = 1,
    ModelRotationPlaneZx = 2,
    ModelRotationPlaneXyReverseRotation = 3,
    ModelRotationPlaneYzReverseRotation = 4,
    ModelRotationPlaneZxReverseRotation = 5,
} CubemodelModelRotationPlaneEnum;

typedef enum
{
    ModelAnimationStill = 0,
    ModelAnimationAnimated = 1,
    ModelAnimationAnimatedPlayInReverse = 2,
} CubemodelModelAnimationEnum;

#define ModelRotationPlaneXyMask (1 << 0)
#define ModelRotationPlaneYzMask (1 << 1)
#define ModelRotationPlaneZxMask (1 << 2)
#define ModelRotationPlaneXyReverseRotationMask (1 << 3)
#define ModelRotationPlaneYzReverseRotationMask (1 << 4)
#define ModelRotationPlaneZxReverseRotationMask (1 << 5)


#define ModelAnimationStillMask (1 << 0)
#define ModelAnimationAnimatedMask (1 << 1)
#define ModelAnimationAnimatedPlayInReverseMask (1 << 2)


float            cubemodelGetGlobalModelScaleFactor (CompScreen *s);
CompOption *     cubemodelGetGlobalModelScaleFactorOption (CompScreen *s);
void             cubemodelSetGlobalModelScaleFactorNotify (CompScreen *s, cubemodelScreenOptionChangeNotifyProc notify);

CompListValue *  cubemodelGetModelFilename (CompScreen *s);
CompOption *     cubemodelGetModelFilenameOption (CompScreen *s);
void             cubemodelSetModelFilenameNotify (CompScreen *s, cubemodelScreenOptionChangeNotifyProc notify);

CompListValue *  cubemodelGetModelScaleFactor (CompScreen *s);
CompOption *     cubemodelGetModelScaleFactorOption (CompScreen *s);
void             cubemodelSetModelScaleFactorNotify (CompScreen *s, cubemodelScreenOptionChangeNotifyProc notify);

CompListValue *  cubemodelGetModelXOffset (CompScreen *s);
CompOption *     cubemodelGetModelXOffsetOption (CompScreen *s);
void             cubemodelSetModelXOffsetNotify (CompScreen *s, cubemodelScreenOptionChangeNotifyProc notify);

CompListValue *  cubemodelGetModelYOffset (CompScreen *s);
CompOption *     cubemodelGetModelYOffsetOption (CompScreen *s);
void             cubemodelSetModelYOffsetNotify (CompScreen *s, cubemodelScreenOptionChangeNotifyProc notify);

CompListValue *  cubemodelGetModelZOffset (CompScreen *s);
CompOption *     cubemodelGetModelZOffsetOption (CompScreen *s);
void             cubemodelSetModelZOffsetNotify (CompScreen *s, cubemodelScreenOptionChangeNotifyProc notify);

CompListValue *  cubemodelGetModelRotationPlane (CompScreen *s);
unsigned int     cubemodelGetModelRotationPlaneMask (CompScreen *s);
CompOption *     cubemodelGetModelRotationPlaneOption (CompScreen *s);
void             cubemodelSetModelRotationPlaneNotify (CompScreen *s, cubemodelScreenOptionChangeNotifyProc notify);

CompListValue *  cubemodelGetModelRotationRate (CompScreen *s);
CompOption *     cubemodelGetModelRotationRateOption (CompScreen *s);
void             cubemodelSetModelRotationRateNotify (CompScreen *s, cubemodelScreenOptionChangeNotifyProc notify);

CompListValue *  cubemodelGetModelAnimation (CompScreen *s);
unsigned int     cubemodelGetModelAnimationMask (CompScreen *s);
CompOption *     cubemodelGetModelAnimationOption (CompScreen *s);
void             cubemodelSetModelAnimationNotify (CompScreen *s, cubemodelScreenOptionChangeNotifyProc notify);

CompListValue *  cubemodelGetModelFps (CompScreen *s);
CompOption *     cubemodelGetModelFpsOption (CompScreen *s);
void             cubemodelSetModelFpsNotify (CompScreen *s, cubemodelScreenOptionChangeNotifyProc notify);

Bool             cubemodelGetRescaleWidth (CompScreen *s);
CompOption *     cubemodelGetRescaleWidthOption (CompScreen *s);
void             cubemodelSetRescaleWidthNotify (CompScreen *s, cubemodelScreenOptionChangeNotifyProc notify);

Bool             cubemodelGetRenderFrontAndBack (CompScreen *s);
CompOption *     cubemodelGetRenderFrontAndBackOption (CompScreen *s);
void             cubemodelSetRenderFrontAndBackNotify (CompScreen *s, cubemodelScreenOptionChangeNotifyProc notify);

Bool             cubemodelGetRotateLighting (CompScreen *s);
CompOption *     cubemodelGetRotateLightingOption (CompScreen *s);
void             cubemodelSetRotateLightingNotify (CompScreen *s, cubemodelScreenOptionChangeNotifyProc notify);

float            cubemodelGetLightInclination (CompScreen *s);
CompOption *     cubemodelGetLightInclinationOption (CompScreen *s);
void             cubemodelSetLightInclinationNotify (CompScreen *s, cubemodelScreenOptionChangeNotifyProc notify);

float            cubemodelGetLightAmbient (CompScreen *s);
CompOption *     cubemodelGetLightAmbientOption (CompScreen *s);
void             cubemodelSetLightAmbientNotify (CompScreen *s, cubemodelScreenOptionChangeNotifyProc notify);

float            cubemodelGetLightDiffuse (CompScreen *s);
CompOption *     cubemodelGetLightDiffuseOption (CompScreen *s);
void             cubemodelSetLightDiffuseNotify (CompScreen *s, cubemodelScreenOptionChangeNotifyProc notify);

float            cubemodelGetLightSpecular (CompScreen *s);
CompOption *     cubemodelGetLightSpecularOption (CompScreen *s);
void             cubemodelSetLightSpecularNotify (CompScreen *s, cubemodelScreenOptionChangeNotifyProc notify);

Bool             cubemodelGetConcurrentLoad (CompScreen *s);
CompOption *     cubemodelGetConcurrentLoadOption (CompScreen *s);
void             cubemodelSetConcurrentLoadNotify (CompScreen *s, cubemodelScreenOptionChangeNotifyProc notify);

#ifndef GENERIC_PRIVATE_DEFINES
#define GENERIC_PRIVATE_DEFINES

#define GET_PLUGIN_CORE(object, plugin) \
    ((plugin##Core *) (object)->base.privates[plugin##CorePrivateIndex].ptr)
#define PLUGIN_CORE(object, plugin, prefix) \
    plugin##Core * prefix##c = GET_PLUGIN_CORE (object, plugin)

#define GET_PLUGIN_DISPLAY(object, plugin) \
    ((plugin##Display *) \
	(object)->base.privates[plugin##DisplayPrivateIndex].ptr)
#define PLUGIN_DISPLAY(object, plugin, prefix) \
    plugin##Display * prefix##d = GET_PLUGIN_DISPLAY (object, plugin)

#define GET_PLUGIN_SCREEN(object, parent, plugin) \
    ((plugin##Screen *) \
	(object)->base.privates[(parent)->screenPrivateIndex].ptr)
#define PLUGIN_SCREEN(object, plugin, prefix) \
    plugin##Screen * prefix##s = \
	GET_PLUGIN_SCREEN (object, \
	GET_PLUGIN_DISPLAY ((object)->display, plugin), plugin)

#define GET_PLUGIN_WINDOW(object, parent, plugin) \
    ((plugin##Window *) \
	(object)->base.privates[(parent)->windowPrivateIndex].ptr)
#define PLUGIN_WINDOW(object, plugin, prefix) \
    plugin##Window * prefix##w = \
	GET_PLUGIN_WINDOW  (object, \
	GET_PLUGIN_SCREEN  ((object)->screen, \
	GET_PLUGIN_DISPLAY ((object)->screen->display, plugin), plugin), plugin)

#endif

COMPIZ_END_DECLS

#endif
