/*
 * This file is autogenerated with bcop:
 * The Compiz option code generator
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <compiz-core.h>

#include "dialog_options.h"

static int DialogOptionsDisplayPrivateIndex;

static CompMetadata dialogOptionsMetadata;

static CompPluginVTable *dialogPluginVTable = NULL;
CompPluginVTable dialogOptionsVTable;

#define DIALOG_OPTIONS_DISPLAY(d) PLUGIN_DISPLAY(d, DialogOptions, o)
#define DIALOG_OPTIONS_SCREEN(s) PLUGIN_SCREEN(s, DialogOptions, o)

typedef struct _DialogOptionsDisplay
{
    int screenPrivateIndex;

    CompOption opt[DialogDisplayOptionNum];
    dialogDisplayOptionChangeNotifyProc notify[DialogDisplayOptionNum];
} DialogOptionsDisplay;

typedef struct _DialogOptionsScreen
{
} DialogOptionsScreen;

CompMatch * dialogGetDialogtypes (CompDisplay *d)
{
    DIALOG_OPTIONS_DISPLAY(d);
    return &od->opt[DialogDisplayOptionDialogtypes].value.match;
}

CompOption * dialogGetDialogtypesOption (CompDisplay *d)
{
    DIALOG_OPTIONS_DISPLAY(d);
    return &od->opt[DialogDisplayOptionDialogtypes];
}

void dialogSetDialogtypesNotify (CompDisplay *d, dialogDisplayOptionChangeNotifyProc notify)
{
    DIALOG_OPTIONS_DISPLAY(d);
    od->notify[DialogDisplayOptionDialogtypes] = notify;
}

float dialogGetSpeed (CompDisplay *d)
{
    DIALOG_OPTIONS_DISPLAY(d);
    return od->opt[DialogDisplayOptionSpeed].value.f;
}

CompOption * dialogGetSpeedOption (CompDisplay *d)
{
    DIALOG_OPTIONS_DISPLAY(d);
    return &od->opt[DialogDisplayOptionSpeed];
}

void dialogSetSpeedNotify (CompDisplay *d, dialogDisplayOptionChangeNotifyProc notify)
{
    DIALOG_OPTIONS_DISPLAY(d);
    od->notify[DialogDisplayOptionSpeed] = notify;
}

float dialogGetOpacity (CompDisplay *d)
{
    DIALOG_OPTIONS_DISPLAY(d);
    return od->opt[DialogDisplayOptionOpacity].value.f;
}

CompOption * dialogGetOpacityOption (CompDisplay *d)
{
    DIALOG_OPTIONS_DISPLAY(d);
    return &od->opt[DialogDisplayOptionOpacity];
}

void dialogSetOpacityNotify (CompDisplay *d, dialogDisplayOptionChangeNotifyProc notify)
{
    DIALOG_OPTIONS_DISPLAY(d);
    od->notify[DialogDisplayOptionOpacity] = notify;
}

float dialogGetSaturation (CompDisplay *d)
{
    DIALOG_OPTIONS_DISPLAY(d);
    return od->opt[DialogDisplayOptionSaturation].value.f;
}

CompOption * dialogGetSaturationOption (CompDisplay *d)
{
    DIALOG_OPTIONS_DISPLAY(d);
    return &od->opt[DialogDisplayOptionSaturation];
}

void dialogSetSaturationNotify (CompDisplay *d, dialogDisplayOptionChangeNotifyProc notify)
{
    DIALOG_OPTIONS_DISPLAY(d);
    od->notify[DialogDisplayOptionSaturation] = notify;
}

float dialogGetBrightness (CompDisplay *d)
{
    DIALOG_OPTIONS_DISPLAY(d);
    return od->opt[DialogDisplayOptionBrightness].value.f;
}

CompOption * dialogGetBrightnessOption (CompDisplay *d)
{
    DIALOG_OPTIONS_DISPLAY(d);
    return &od->opt[DialogDisplayOptionBrightness];
}

void dialogSetBrightnessNotify (CompDisplay *d, dialogDisplayOptionChangeNotifyProc notify)
{
    DIALOG_OPTIONS_DISPLAY(d);
    od->notify[DialogDisplayOptionBrightness] = notify;
}

CompOption * dialogGetDisplayOption (CompDisplay *d, DialogDisplayOptions num)
{
    DIALOG_OPTIONS_DISPLAY(d);
    return &od->opt[num];
}

static const CompMetadataOptionInfo dialogOptionsDisplayOptionInfo[] = {
    { "dialogtypes", "match", 0, 0, 0 },
    { "speed", "float", "<min>1</min><max>100</max>", 0, 0 },
    { "opacity", "float", "<min>0</min><max>100</max>", 0, 0 },
    { "saturation", "float", "<min>0</min><max>100</max>", 0, 0 },
    { "brightness", "float", "<min>0</min><max>100</max>", 0, 0 },
};

static Bool dialogOptionsSetDisplayOption (CompPlugin *plugin, CompDisplay *d, const char *name, CompOptionValue *value)
{
    DIALOG_OPTIONS_DISPLAY(d);
    CompOption *o;
    int        index;

    o = compFindOption (od->opt, DialogDisplayOptionNum, name, &index);

    if (!o)
        return FALSE;

    switch (index)
    {
     case DialogDisplayOptionDialogtypes:
        if (compSetDisplayOption (d, o, value))
        {
            if (od->notify[DialogDisplayOptionDialogtypes])
                (*od->notify[DialogDisplayOptionDialogtypes]) (d, o, DialogDisplayOptionDialogtypes);
            return TRUE;
        }
        break;
     case DialogDisplayOptionSpeed:
        if (compSetDisplayOption (d, o, value))
        {
            if (od->notify[DialogDisplayOptionSpeed])
                (*od->notify[DialogDisplayOptionSpeed]) (d, o, DialogDisplayOptionSpeed);
            return TRUE;
        }
        break;
     case DialogDisplayOptionOpacity:
        if (compSetDisplayOption (d, o, value))
        {
            if (od->notify[DialogDisplayOptionOpacity])
                (*od->notify[DialogDisplayOptionOpacity]) (d, o, DialogDisplayOptionOpacity);
            return TRUE;
        }
        break;
     case DialogDisplayOptionSaturation:
        if (compSetDisplayOption (d, o, value))
        {
            if (od->notify[DialogDisplayOptionSaturation])
                (*od->notify[DialogDisplayOptionSaturation]) (d, o, DialogDisplayOptionSaturation);
            return TRUE;
        }
        break;
     case DialogDisplayOptionBrightness:
        if (compSetDisplayOption (d, o, value))
        {
            if (od->notify[DialogDisplayOptionBrightness])
                (*od->notify[DialogDisplayOptionBrightness]) (d, o, DialogDisplayOptionBrightness);
            return TRUE;
        }
        break;
    default:
        break;
    }
    return FALSE;
}

static CompOption * dialogOptionsGetDisplayOptions (CompPlugin *plugin, CompDisplay *d, int *count)
{
    DIALOG_OPTIONS_DISPLAY(d);
    if (!od)
    {
        *count = 0;
        return NULL;
    }
    *count = DialogDisplayOptionNum;
    return od->opt;
}

static Bool dialogOptionsInitScreen (CompPlugin *p, CompScreen *s)
{
    DialogOptionsScreen *os;
    
    DIALOG_OPTIONS_DISPLAY (s->display);

    os = calloc (1, sizeof(DialogOptionsScreen));
    if (!os)
        return FALSE;

    s->base.privates[od->screenPrivateIndex].ptr = os;

    
    return TRUE;
}

static void dialogOptionsFiniScreen (CompPlugin *p, CompScreen *s)
{
    DIALOG_OPTIONS_SCREEN (s);
    DIALOG_OPTIONS_DISPLAY (s->display);

    free (os);
    s->base.privates[od->screenPrivateIndex].ptr = NULL;
}

static Bool dialogOptionsInitDisplay (CompPlugin *p, CompDisplay *d)
{
    DialogOptionsDisplay *od;
   
    
    od = calloc (1, sizeof(DialogOptionsDisplay));
    if (!od)
        return FALSE;

    od->screenPrivateIndex = allocateScreenPrivateIndex(d);
    if (od->screenPrivateIndex < 0)
    {
        free(od);
        return FALSE;
    }

    d->base.privates[DialogOptionsDisplayPrivateIndex].ptr = od;

    if (!compInitDisplayOptionsFromMetadata (d, &dialogOptionsMetadata, dialogOptionsDisplayOptionInfo, od->opt, DialogDisplayOptionNum))
    {
        free (od);
        return FALSE;
    }

    return TRUE;
}

static void dialogOptionsFiniDisplay (CompPlugin *p, CompDisplay *d)
{
    DIALOG_OPTIONS_DISPLAY (d);

    freeScreenPrivateIndex(d, od->screenPrivateIndex);

    compFiniDisplayOptions (d, od->opt, DialogDisplayOptionNum);

    free (od);
    d->base.privates[DialogOptionsDisplayPrivateIndex].ptr = NULL;
}

static Bool dialogOptionsInit (CompPlugin *p)
{
    DialogOptionsDisplayPrivateIndex = allocateDisplayPrivateIndex();
    if (DialogOptionsDisplayPrivateIndex < 0)
        return FALSE;

    if (!compInitPluginMetadataFromInfo (&dialogOptionsMetadata, "dialog",dialogOptionsDisplayOptionInfo, DialogDisplayOptionNum, 0, 0))
        return FALSE;

    compAddMetadataFromFile (&dialogOptionsMetadata, "dialog");
    if (dialogPluginVTable && dialogPluginVTable->init)
        return dialogPluginVTable->init (p);
    return TRUE;
}

static void dialogOptionsFini (CompPlugin *p)
{
    if (dialogPluginVTable && dialogPluginVTable->fini)
        dialogPluginVTable->fini (p);

    if (DialogOptionsDisplayPrivateIndex >= 0)
        freeDisplayPrivateIndex (DialogOptionsDisplayPrivateIndex);

    compFiniMetadata (&dialogOptionsMetadata);
}

static CompBool dialogOptionsInitObject (CompPlugin *p, CompObject *o)
{
    static InitPluginObjectProc dispTab[] = {
        (InitPluginObjectProc) 0,
        (InitPluginObjectProc) dialogOptionsInitDisplay,
        (InitPluginObjectProc) dialogOptionsInitScreen
    };

    RETURN_DISPATCH (o, dispTab, ARRAY_SIZE (dispTab), TRUE, (p, o));
}

static void dialogOptionsFiniObject (CompPlugin *p, CompObject *o)
{
    static FiniPluginObjectProc dispTab[] = {
        (FiniPluginObjectProc) 0,
        (FiniPluginObjectProc) dialogOptionsFiniDisplay,
        (FiniPluginObjectProc) dialogOptionsFiniScreen
    };

    DISPATCH (o, dispTab, ARRAY_SIZE (dispTab), (p, o));
}

static CompBool dialogOptionsInitObjectWrapper (CompPlugin *p, CompObject *o)
{
    CompBool rv = TRUE;
    rv = dialogOptionsInitObject (p, o);
    if (dialogPluginVTable->initObject)
        rv &= dialogPluginVTable->initObject (p, o);
    return rv;
}

static void dialogOptionsFiniObjectWrapper (CompPlugin *p, CompObject *o)
{
    if (dialogPluginVTable->finiObject)
        dialogPluginVTable->finiObject (p, o);
    dialogOptionsFiniObject (p, o);
}

static CompOption * dialogOptionsGetObjectOptions (CompPlugin *p, CompObject *o, int *count)
{
    static GetPluginObjectOptionsProc dispTab[] = {
        (GetPluginObjectOptionsProc) 0,
            (GetPluginObjectOptionsProc) dialogOptionsGetDisplayOptions,
    };

    *count = 0;
    RETURN_DISPATCH (o, dispTab, ARRAY_SIZE (dispTab),
		     NULL, (p, o, count));
}

static CompBool dialogOptionsSetObjectOption (CompPlugin *p, CompObject *o, const char *name, CompOptionValue *value)
{
    static SetPluginObjectOptionProc dispTab[] = {
        (SetPluginObjectOptionProc) 0,
        (SetPluginObjectOptionProc) dialogOptionsSetDisplayOption,
    };

    RETURN_DISPATCH (o, dispTab, ARRAY_SIZE (dispTab), FALSE,
		     (p, o, name, value));
}

static CompMetadata *
dialogOptionsGetMetadata (CompPlugin *plugin)
{
    return &dialogOptionsMetadata;
}

CompPluginVTable *getCompPluginInfo20070830 (void)
{
    if (!dialogPluginVTable)
    {
        dialogPluginVTable = getCompPluginInfo ();
        memcpy(&dialogOptionsVTable, dialogPluginVTable, sizeof(CompPluginVTable));
        dialogOptionsVTable.getMetadata = dialogOptionsGetMetadata;
        dialogOptionsVTable.init = dialogOptionsInit;
        dialogOptionsVTable.fini = dialogOptionsFini;
        dialogOptionsVTable.initObject = dialogOptionsInitObjectWrapper;
        dialogOptionsVTable.finiObject = dialogOptionsFiniObjectWrapper;
        dialogOptionsVTable.getObjectOptions = dialogOptionsGetObjectOptions;
	dialogOptionsVTable.setObjectOption = dialogOptionsSetObjectOption;
	
    }
    return &dialogOptionsVTable;
}

