/*
 * This file is autogenerated with bcop:
 * The Compiz option code generator
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 */

#ifndef _ELEMENTS_OPTIONS_H
#define _ELEMENTS_OPTIONS_H

#include <compiz-common.h>

COMPIZ_BEGIN_DECLS

CompPluginVTable * getCompPluginInfo (void);

typedef enum
{
    ElementsDisplayOptionGlobalSpeed,
    ElementsDisplayOptionScreenDepth,
    ElementsDisplayOptionApplyTransform,
    ElementsDisplayOptionOverWindows,
    ElementsDisplayOptionToggle,
    ElementsDisplayOptionNumSnowflakes,
    ElementsDisplayOptionSnowSize,
    ElementsDisplayOptionSnowSpeed,
    ElementsDisplayOptionSnowSway,
    ElementsDisplayOptionSnowRotate,
    ElementsDisplayOptionToggleSnowCheck,
    ElementsDisplayOptionToggleSnowKey,
    ElementsDisplayOptionWindDirection,
    ElementsDisplayOptionSnowTextures,
    ElementsDisplayOptionNumLeaves,
    ElementsDisplayOptionLeafSize,
    ElementsDisplayOptionAutumnSway,
    ElementsDisplayOptionAutumnSpeed,
    ElementsDisplayOptionAutumnRotate,
    ElementsDisplayOptionToggleAutumnCheck,
    ElementsDisplayOptionToggleAutumnKey,
    ElementsDisplayOptionLeafTextures,
    ElementsDisplayOptionNumBubbles,
    ElementsDisplayOptionBubblesSize,
    ElementsDisplayOptionViscosity,
    ElementsDisplayOptionBubblesRotate,
    ElementsDisplayOptionToggleBubblesCheck,
    ElementsDisplayOptionToggleBubblesKey,
    ElementsDisplayOptionBubblesTextures,
    ElementsDisplayOptionNumFireflies,
    ElementsDisplayOptionFireflySize,
    ElementsDisplayOptionFireflySpeed,
    ElementsDisplayOptionFirefliesRotate,
    ElementsDisplayOptionToggleFirefliesCheck,
    ElementsDisplayOptionToggleFirefliesKey,
    ElementsDisplayOptionFirefliesTextures,
    ElementsDisplayOptionNumStars,
    ElementsDisplayOptionStarsSize,
    ElementsDisplayOptionStarsSpeed,
    ElementsDisplayOptionStarOffsetX,
    ElementsDisplayOptionStarOffsetY,
    ElementsDisplayOptionStarsRotate,
    ElementsDisplayOptionToggleStarsCheck,
    ElementsDisplayOptionToggleStarsKey,
    ElementsDisplayOptionStarsTextures,
    ElementsDisplayOptionNum
} ElementsDisplayOptions;

typedef void (*elementsDisplayOptionChangeNotifyProc) (CompDisplay *display, CompOption *opt, ElementsDisplayOptions num);

CompOption *elementsGetDisplayOption (CompDisplay *d, ElementsDisplayOptions num);

typedef enum
{
    ElementsScreenOptionNum
} ElementsScreenOptions;

typedef void (*elementsScreenOptionChangeNotifyProc) (CompScreen *screen, CompOption *opt, ElementsScreenOptions num);

CompOption *elementsGetScreenOption (CompScreen *s, ElementsScreenOptions num);

typedef enum
{
    WindDirectionNone = 0,
    WindDirectionUp = 1,
    WindDirectionLeft = 2,
    WindDirectionRight = 3,
} ElementsWindDirectionEnum;

float            elementsGetGlobalSpeed (CompDisplay *d);
CompOption *     elementsGetGlobalSpeedOption (CompDisplay *d);
void             elementsSetGlobalSpeedNotify (CompDisplay *d, elementsDisplayOptionChangeNotifyProc notify);

int              elementsGetScreenDepth (CompDisplay *d);
CompOption *     elementsGetScreenDepthOption (CompDisplay *d);
void             elementsSetScreenDepthNotify (CompDisplay *d, elementsDisplayOptionChangeNotifyProc notify);

Bool             elementsGetApplyTransform (CompDisplay *d);
CompOption *     elementsGetApplyTransformOption (CompDisplay *d);
void             elementsSetApplyTransformNotify (CompDisplay *d, elementsDisplayOptionChangeNotifyProc notify);

Bool             elementsGetOverWindows (CompDisplay *d);
CompOption *     elementsGetOverWindowsOption (CompDisplay *d);
void             elementsSetOverWindowsNotify (CompDisplay *d, elementsDisplayOptionChangeNotifyProc notify);

Bool             elementsGetToggle (CompDisplay *d);
CompOption *     elementsGetToggleOption (CompDisplay *d);
void             elementsSetToggleNotify (CompDisplay *d, elementsDisplayOptionChangeNotifyProc notify);

int              elementsGetNumSnowflakes (CompDisplay *d);
CompOption *     elementsGetNumSnowflakesOption (CompDisplay *d);
void             elementsSetNumSnowflakesNotify (CompDisplay *d, elementsDisplayOptionChangeNotifyProc notify);

float            elementsGetSnowSize (CompDisplay *d);
CompOption *     elementsGetSnowSizeOption (CompDisplay *d);
void             elementsSetSnowSizeNotify (CompDisplay *d, elementsDisplayOptionChangeNotifyProc notify);

int              elementsGetSnowSpeed (CompDisplay *d);
CompOption *     elementsGetSnowSpeedOption (CompDisplay *d);
void             elementsSetSnowSpeedNotify (CompDisplay *d, elementsDisplayOptionChangeNotifyProc notify);

int              elementsGetSnowSway (CompDisplay *d);
CompOption *     elementsGetSnowSwayOption (CompDisplay *d);
void             elementsSetSnowSwayNotify (CompDisplay *d, elementsDisplayOptionChangeNotifyProc notify);

Bool             elementsGetSnowRotate (CompDisplay *d);
CompOption *     elementsGetSnowRotateOption (CompDisplay *d);
void             elementsSetSnowRotateNotify (CompDisplay *d, elementsDisplayOptionChangeNotifyProc notify);

Bool             elementsGetToggleSnowCheck (CompDisplay *d);
CompOption *     elementsGetToggleSnowCheckOption (CompDisplay *d);
void             elementsSetToggleSnowCheckNotify (CompDisplay *d, elementsDisplayOptionChangeNotifyProc notify);

CompAction *     elementsGetToggleSnowKey (CompDisplay *d);
void             elementsSetToggleSnowKeyInitiate (CompDisplay *d, CompActionCallBackProc init);
void             elementsSetToggleSnowKeyTerminate (CompDisplay *d, CompActionCallBackProc term);
CompOption *     elementsGetToggleSnowKeyOption (CompDisplay *d);
void             elementsSetToggleSnowKeyNotify (CompDisplay *d, elementsDisplayOptionChangeNotifyProc notify);

int              elementsGetWindDirection (CompDisplay *d);
CompOption *     elementsGetWindDirectionOption (CompDisplay *d);
void             elementsSetWindDirectionNotify (CompDisplay *d, elementsDisplayOptionChangeNotifyProc notify);

CompListValue *  elementsGetSnowTextures (CompDisplay *d);
CompOption *     elementsGetSnowTexturesOption (CompDisplay *d);
void             elementsSetSnowTexturesNotify (CompDisplay *d, elementsDisplayOptionChangeNotifyProc notify);

int              elementsGetNumLeaves (CompDisplay *d);
CompOption *     elementsGetNumLeavesOption (CompDisplay *d);
void             elementsSetNumLeavesNotify (CompDisplay *d, elementsDisplayOptionChangeNotifyProc notify);

float            elementsGetLeafSize (CompDisplay *d);
CompOption *     elementsGetLeafSizeOption (CompDisplay *d);
void             elementsSetLeafSizeNotify (CompDisplay *d, elementsDisplayOptionChangeNotifyProc notify);

float            elementsGetAutumnSway (CompDisplay *d);
CompOption *     elementsGetAutumnSwayOption (CompDisplay *d);
void             elementsSetAutumnSwayNotify (CompDisplay *d, elementsDisplayOptionChangeNotifyProc notify);

int              elementsGetAutumnSpeed (CompDisplay *d);
CompOption *     elementsGetAutumnSpeedOption (CompDisplay *d);
void             elementsSetAutumnSpeedNotify (CompDisplay *d, elementsDisplayOptionChangeNotifyProc notify);

Bool             elementsGetAutumnRotate (CompDisplay *d);
CompOption *     elementsGetAutumnRotateOption (CompDisplay *d);
void             elementsSetAutumnRotateNotify (CompDisplay *d, elementsDisplayOptionChangeNotifyProc notify);

Bool             elementsGetToggleAutumnCheck (CompDisplay *d);
CompOption *     elementsGetToggleAutumnCheckOption (CompDisplay *d);
void             elementsSetToggleAutumnCheckNotify (CompDisplay *d, elementsDisplayOptionChangeNotifyProc notify);

CompAction *     elementsGetToggleAutumnKey (CompDisplay *d);
void             elementsSetToggleAutumnKeyInitiate (CompDisplay *d, CompActionCallBackProc init);
void             elementsSetToggleAutumnKeyTerminate (CompDisplay *d, CompActionCallBackProc term);
CompOption *     elementsGetToggleAutumnKeyOption (CompDisplay *d);
void             elementsSetToggleAutumnKeyNotify (CompDisplay *d, elementsDisplayOptionChangeNotifyProc notify);

CompListValue *  elementsGetLeafTextures (CompDisplay *d);
CompOption *     elementsGetLeafTexturesOption (CompDisplay *d);
void             elementsSetLeafTexturesNotify (CompDisplay *d, elementsDisplayOptionChangeNotifyProc notify);

int              elementsGetNumBubbles (CompDisplay *d);
CompOption *     elementsGetNumBubblesOption (CompDisplay *d);
void             elementsSetNumBubblesNotify (CompDisplay *d, elementsDisplayOptionChangeNotifyProc notify);

float            elementsGetBubblesSize (CompDisplay *d);
CompOption *     elementsGetBubblesSizeOption (CompDisplay *d);
void             elementsSetBubblesSizeNotify (CompDisplay *d, elementsDisplayOptionChangeNotifyProc notify);

float            elementsGetViscosity (CompDisplay *d);
CompOption *     elementsGetViscosityOption (CompDisplay *d);
void             elementsSetViscosityNotify (CompDisplay *d, elementsDisplayOptionChangeNotifyProc notify);

Bool             elementsGetBubblesRotate (CompDisplay *d);
CompOption *     elementsGetBubblesRotateOption (CompDisplay *d);
void             elementsSetBubblesRotateNotify (CompDisplay *d, elementsDisplayOptionChangeNotifyProc notify);

Bool             elementsGetToggleBubblesCheck (CompDisplay *d);
CompOption *     elementsGetToggleBubblesCheckOption (CompDisplay *d);
void             elementsSetToggleBubblesCheckNotify (CompDisplay *d, elementsDisplayOptionChangeNotifyProc notify);

CompAction *     elementsGetToggleBubblesKey (CompDisplay *d);
void             elementsSetToggleBubblesKeyInitiate (CompDisplay *d, CompActionCallBackProc init);
void             elementsSetToggleBubblesKeyTerminate (CompDisplay *d, CompActionCallBackProc term);
CompOption *     elementsGetToggleBubblesKeyOption (CompDisplay *d);
void             elementsSetToggleBubblesKeyNotify (CompDisplay *d, elementsDisplayOptionChangeNotifyProc notify);

CompListValue *  elementsGetBubblesTextures (CompDisplay *d);
CompOption *     elementsGetBubblesTexturesOption (CompDisplay *d);
void             elementsSetBubblesTexturesNotify (CompDisplay *d, elementsDisplayOptionChangeNotifyProc notify);

int              elementsGetNumFireflies (CompDisplay *d);
CompOption *     elementsGetNumFirefliesOption (CompDisplay *d);
void             elementsSetNumFirefliesNotify (CompDisplay *d, elementsDisplayOptionChangeNotifyProc notify);

float            elementsGetFireflySize (CompDisplay *d);
CompOption *     elementsGetFireflySizeOption (CompDisplay *d);
void             elementsSetFireflySizeNotify (CompDisplay *d, elementsDisplayOptionChangeNotifyProc notify);

int              elementsGetFireflySpeed (CompDisplay *d);
CompOption *     elementsGetFireflySpeedOption (CompDisplay *d);
void             elementsSetFireflySpeedNotify (CompDisplay *d, elementsDisplayOptionChangeNotifyProc notify);

Bool             elementsGetFirefliesRotate (CompDisplay *d);
CompOption *     elementsGetFirefliesRotateOption (CompDisplay *d);
void             elementsSetFirefliesRotateNotify (CompDisplay *d, elementsDisplayOptionChangeNotifyProc notify);

Bool             elementsGetToggleFirefliesCheck (CompDisplay *d);
CompOption *     elementsGetToggleFirefliesCheckOption (CompDisplay *d);
void             elementsSetToggleFirefliesCheckNotify (CompDisplay *d, elementsDisplayOptionChangeNotifyProc notify);

CompAction *     elementsGetToggleFirefliesKey (CompDisplay *d);
void             elementsSetToggleFirefliesKeyInitiate (CompDisplay *d, CompActionCallBackProc init);
void             elementsSetToggleFirefliesKeyTerminate (CompDisplay *d, CompActionCallBackProc term);
CompOption *     elementsGetToggleFirefliesKeyOption (CompDisplay *d);
void             elementsSetToggleFirefliesKeyNotify (CompDisplay *d, elementsDisplayOptionChangeNotifyProc notify);

CompListValue *  elementsGetFirefliesTextures (CompDisplay *d);
CompOption *     elementsGetFirefliesTexturesOption (CompDisplay *d);
void             elementsSetFirefliesTexturesNotify (CompDisplay *d, elementsDisplayOptionChangeNotifyProc notify);

int              elementsGetNumStars (CompDisplay *d);
CompOption *     elementsGetNumStarsOption (CompDisplay *d);
void             elementsSetNumStarsNotify (CompDisplay *d, elementsDisplayOptionChangeNotifyProc notify);

float            elementsGetStarsSize (CompDisplay *d);
CompOption *     elementsGetStarsSizeOption (CompDisplay *d);
void             elementsSetStarsSizeNotify (CompDisplay *d, elementsDisplayOptionChangeNotifyProc notify);

int              elementsGetStarsSpeed (CompDisplay *d);
CompOption *     elementsGetStarsSpeedOption (CompDisplay *d);
void             elementsSetStarsSpeedNotify (CompDisplay *d, elementsDisplayOptionChangeNotifyProc notify);

int              elementsGetStarOffsetX (CompDisplay *d);
CompOption *     elementsGetStarOffsetXOption (CompDisplay *d);
void             elementsSetStarOffsetXNotify (CompDisplay *d, elementsDisplayOptionChangeNotifyProc notify);

int              elementsGetStarOffsetY (CompDisplay *d);
CompOption *     elementsGetStarOffsetYOption (CompDisplay *d);
void             elementsSetStarOffsetYNotify (CompDisplay *d, elementsDisplayOptionChangeNotifyProc notify);

Bool             elementsGetStarsRotate (CompDisplay *d);
CompOption *     elementsGetStarsRotateOption (CompDisplay *d);
void             elementsSetStarsRotateNotify (CompDisplay *d, elementsDisplayOptionChangeNotifyProc notify);

Bool             elementsGetToggleStarsCheck (CompDisplay *d);
CompOption *     elementsGetToggleStarsCheckOption (CompDisplay *d);
void             elementsSetToggleStarsCheckNotify (CompDisplay *d, elementsDisplayOptionChangeNotifyProc notify);

CompAction *     elementsGetToggleStarsKey (CompDisplay *d);
void             elementsSetToggleStarsKeyInitiate (CompDisplay *d, CompActionCallBackProc init);
void             elementsSetToggleStarsKeyTerminate (CompDisplay *d, CompActionCallBackProc term);
CompOption *     elementsGetToggleStarsKeyOption (CompDisplay *d);
void             elementsSetToggleStarsKeyNotify (CompDisplay *d, elementsDisplayOptionChangeNotifyProc notify);

CompListValue *  elementsGetStarsTextures (CompDisplay *d);
CompOption *     elementsGetStarsTexturesOption (CompDisplay *d);
void             elementsSetStarsTexturesNotify (CompDisplay *d, elementsDisplayOptionChangeNotifyProc notify);

#ifndef GENERIC_PRIVATE_DEFINES
#define GENERIC_PRIVATE_DEFINES

#define GET_PLUGIN_CORE(object, plugin) \
    ((plugin##Core *) (object)->base.privates[plugin##CorePrivateIndex].ptr)
#define PLUGIN_CORE(object, plugin, prefix) \
    plugin##Core * prefix##c = GET_PLUGIN_CORE (object, plugin)

#define GET_PLUGIN_DISPLAY(object, plugin) \
    ((plugin##Display *) \
	(object)->base.privates[plugin##DisplayPrivateIndex].ptr)
#define PLUGIN_DISPLAY(object, plugin, prefix) \
    plugin##Display * prefix##d = GET_PLUGIN_DISPLAY (object, plugin)

#define GET_PLUGIN_SCREEN(object, parent, plugin) \
    ((plugin##Screen *) \
	(object)->base.privates[(parent)->screenPrivateIndex].ptr)
#define PLUGIN_SCREEN(object, plugin, prefix) \
    plugin##Screen * prefix##s = \
	GET_PLUGIN_SCREEN (object, \
	GET_PLUGIN_DISPLAY ((object)->display, plugin), plugin)

#define GET_PLUGIN_WINDOW(object, parent, plugin) \
    ((plugin##Window *) \
	(object)->base.privates[(parent)->windowPrivateIndex].ptr)
#define PLUGIN_WINDOW(object, plugin, prefix) \
    plugin##Window * prefix##w = \
	GET_PLUGIN_WINDOW  (object, \
	GET_PLUGIN_SCREEN  ((object)->screen, \
	GET_PLUGIN_DISPLAY ((object)->screen->display, plugin), plugin), plugin)

#endif

COMPIZ_END_DECLS

#endif
