/*
 * This file is autogenerated with bcop:
 * The Compiz option code generator
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 */

#ifndef _FIREFLIES_OPTIONS_H
#define _FIREFLIES_OPTIONS_H

#include <compiz-common.h>

COMPIZ_BEGIN_DECLS

CompPluginVTable * getCompPluginInfo (void);

typedef enum
{
    FirefliesDisplayOptionNumSnowflakes,
    FirefliesDisplayOptionSnowSize,
    FirefliesDisplayOptionSnowSpeed,
    FirefliesDisplayOptionSnowUpdateDelay,
    FirefliesDisplayOptionScreenBoxing,
    FirefliesDisplayOptionScreenDepth,
    FirefliesDisplayOptionSnowOverWindows,
    FirefliesDisplayOptionSnowRotation,
    FirefliesDisplayOptionSnowDirection,
    FirefliesDisplayOptionDefaultEnabled,
    FirefliesDisplayOptionSnowTextures,
    FirefliesDisplayOptionUseBlending,
    FirefliesDisplayOptionUseTextures,
    FirefliesDisplayOptionToggleKey,
    FirefliesDisplayOptionNum
} FirefliesDisplayOptions;

typedef void (*firefliesDisplayOptionChangeNotifyProc) (CompDisplay *display, CompOption *opt, FirefliesDisplayOptions num);

CompOption *firefliesGetDisplayOption (CompDisplay *d, FirefliesDisplayOptions num);

typedef enum
{
    FirefliesScreenOptionNum
} FirefliesScreenOptions;

typedef void (*firefliesScreenOptionChangeNotifyProc) (CompScreen *screen, CompOption *opt, FirefliesScreenOptions num);

CompOption *firefliesGetScreenOption (CompScreen *s, FirefliesScreenOptions num);

typedef enum
{
    SnowDirectionTopToBottom = 0,
    SnowDirectionBottomToTop = 1,
    SnowDirectionRightToLeft = 2,
    SnowDirectionLeftToRight = 3,
} FirefliesSnowDirectionEnum;

int              firefliesGetNumSnowflakes (CompDisplay *d);
CompOption *     firefliesGetNumSnowflakesOption (CompDisplay *d);
void             firefliesSetNumSnowflakesNotify (CompDisplay *d, firefliesDisplayOptionChangeNotifyProc notify);

float            firefliesGetSnowSize (CompDisplay *d);
CompOption *     firefliesGetSnowSizeOption (CompDisplay *d);
void             firefliesSetSnowSizeNotify (CompDisplay *d, firefliesDisplayOptionChangeNotifyProc notify);

int              firefliesGetSnowSpeed (CompDisplay *d);
CompOption *     firefliesGetSnowSpeedOption (CompDisplay *d);
void             firefliesSetSnowSpeedNotify (CompDisplay *d, firefliesDisplayOptionChangeNotifyProc notify);

int              firefliesGetSnowUpdateDelay (CompDisplay *d);
CompOption *     firefliesGetSnowUpdateDelayOption (CompDisplay *d);
void             firefliesSetSnowUpdateDelayNotify (CompDisplay *d, firefliesDisplayOptionChangeNotifyProc notify);

int              firefliesGetScreenBoxing (CompDisplay *d);
CompOption *     firefliesGetScreenBoxingOption (CompDisplay *d);
void             firefliesSetScreenBoxingNotify (CompDisplay *d, firefliesDisplayOptionChangeNotifyProc notify);

int              firefliesGetScreenDepth (CompDisplay *d);
CompOption *     firefliesGetScreenDepthOption (CompDisplay *d);
void             firefliesSetScreenDepthNotify (CompDisplay *d, firefliesDisplayOptionChangeNotifyProc notify);

Bool             firefliesGetSnowOverWindows (CompDisplay *d);
CompOption *     firefliesGetSnowOverWindowsOption (CompDisplay *d);
void             firefliesSetSnowOverWindowsNotify (CompDisplay *d, firefliesDisplayOptionChangeNotifyProc notify);

Bool             firefliesGetSnowRotation (CompDisplay *d);
CompOption *     firefliesGetSnowRotationOption (CompDisplay *d);
void             firefliesSetSnowRotationNotify (CompDisplay *d, firefliesDisplayOptionChangeNotifyProc notify);

int              firefliesGetSnowDirection (CompDisplay *d);
CompOption *     firefliesGetSnowDirectionOption (CompDisplay *d);
void             firefliesSetSnowDirectionNotify (CompDisplay *d, firefliesDisplayOptionChangeNotifyProc notify);

Bool             firefliesGetDefaultEnabled (CompDisplay *d);
CompOption *     firefliesGetDefaultEnabledOption (CompDisplay *d);
void             firefliesSetDefaultEnabledNotify (CompDisplay *d, firefliesDisplayOptionChangeNotifyProc notify);

CompListValue *  firefliesGetSnowTextures (CompDisplay *d);
CompOption *     firefliesGetSnowTexturesOption (CompDisplay *d);
void             firefliesSetSnowTexturesNotify (CompDisplay *d, firefliesDisplayOptionChangeNotifyProc notify);

Bool             firefliesGetUseBlending (CompDisplay *d);
CompOption *     firefliesGetUseBlendingOption (CompDisplay *d);
void             firefliesSetUseBlendingNotify (CompDisplay *d, firefliesDisplayOptionChangeNotifyProc notify);

Bool             firefliesGetUseTextures (CompDisplay *d);
CompOption *     firefliesGetUseTexturesOption (CompDisplay *d);
void             firefliesSetUseTexturesNotify (CompDisplay *d, firefliesDisplayOptionChangeNotifyProc notify);

CompAction *     firefliesGetToggleKey (CompDisplay *d);
void             firefliesSetToggleKeyInitiate (CompDisplay *d, CompActionCallBackProc init);
void             firefliesSetToggleKeyTerminate (CompDisplay *d, CompActionCallBackProc term);
CompOption *     firefliesGetToggleKeyOption (CompDisplay *d);
void             firefliesSetToggleKeyNotify (CompDisplay *d, firefliesDisplayOptionChangeNotifyProc notify);

#ifndef GENERIC_PRIVATE_DEFINES
#define GENERIC_PRIVATE_DEFINES

#define GET_PLUGIN_CORE(object, plugin) \
    ((plugin##Core *) (object)->base.privates[plugin##CorePrivateIndex].ptr)
#define PLUGIN_CORE(object, plugin, prefix) \
    plugin##Core * prefix##c = GET_PLUGIN_CORE (object, plugin)

#define GET_PLUGIN_DISPLAY(object, plugin) \
    ((plugin##Display *) \
	(object)->base.privates[plugin##DisplayPrivateIndex].ptr)
#define PLUGIN_DISPLAY(object, plugin, prefix) \
    plugin##Display * prefix##d = GET_PLUGIN_DISPLAY (object, plugin)

#define GET_PLUGIN_SCREEN(object, parent, plugin) \
    ((plugin##Screen *) \
	(object)->base.privates[(parent)->screenPrivateIndex].ptr)
#define PLUGIN_SCREEN(object, plugin, prefix) \
    plugin##Screen * prefix##s = \
	GET_PLUGIN_SCREEN (object, \
	GET_PLUGIN_DISPLAY ((object)->display, plugin), plugin)

#define GET_PLUGIN_WINDOW(object, parent, plugin) \
    ((plugin##Window *) \
	(object)->base.privates[(parent)->windowPrivateIndex].ptr)
#define PLUGIN_WINDOW(object, plugin, prefix) \
    plugin##Window * prefix##w = \
	GET_PLUGIN_WINDOW  (object, \
	GET_PLUGIN_SCREEN  ((object)->screen, \
	GET_PLUGIN_DISPLAY ((object)->screen->display, plugin), plugin), plugin)

#endif

COMPIZ_END_DECLS

#endif
