/*
 * This file is autogenerated with bcop:
 * The Compiz option code generator
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 */

#ifndef _FREEWINS_OPTIONS_H
#define _FREEWINS_OPTIONS_H

#include <compiz-common.h>

COMPIZ_BEGIN_DECLS

CompPluginVTable * getCompPluginInfo (void);

typedef enum
{
    FreewinsDisplayOptionRotate,
    FreewinsDisplayOptionIncrementRotate,
    FreewinsDisplayOptionScale,
    FreewinsDisplayOptionInitiateRotationButton,
    FreewinsDisplayOptionInitiateScaleButton,
    FreewinsDisplayOptionResetButton,
    FreewinsDisplayOptionResetKey,
    FreewinsDisplayOptionToggleAxisKey,
    FreewinsDisplayOptionSnapMods,
    FreewinsDisplayOptionInvertMods,
    FreewinsDisplayOptionScaleUpButton,
    FreewinsDisplayOptionScaleDownButton,
    FreewinsDisplayOptionScaleUpKey,
    FreewinsDisplayOptionScaleDownKey,
    FreewinsDisplayOptionRotateUpKey,
    FreewinsDisplayOptionRotateDownKey,
    FreewinsDisplayOptionRotateLeftKey,
    FreewinsDisplayOptionRotateRightKey,
    FreewinsDisplayOptionRotateCKey,
    FreewinsDisplayOptionRotateCcKey,
    FreewinsDisplayOptionNum
} FreewinsDisplayOptions;

typedef void (*freewinsDisplayOptionChangeNotifyProc) (CompDisplay *display, CompOption *opt, FreewinsDisplayOptions num);

CompOption *freewinsGetDisplayOption (CompDisplay *d, FreewinsDisplayOptions num);

typedef enum
{
    FreewinsScreenOptionSnap,
    FreewinsScreenOptionSnapThreshold,
    FreewinsScreenOptionMouseSensitivity,
    FreewinsScreenOptionScaleMode,
    FreewinsScreenOptionAllowNegative,
    FreewinsScreenOptionScaleUniform,
    FreewinsScreenOptionMinScale,
    FreewinsScreenOptionZAxisRotation,
    FreewinsScreenOptionRotationAxis,
    FreewinsScreenOption3dPercent,
    FreewinsScreenOptionAutoZoom,
    FreewinsScreenOptionDisableOnTransformedScreen,
    FreewinsScreenOptionSpeed,
    FreewinsScreenOptionRotateIncrementAmount,
    FreewinsScreenOptionScaleIncrementAmount,
    FreewinsScreenOptionShapeWindowTypes,
    FreewinsScreenOptionShapeInput,
    FreewinsScreenOptionImmediateMoves,
    FreewinsScreenOptionCircleColor,
    FreewinsScreenOptionLineColor,
    FreewinsScreenOptionCrossLineColor,
    FreewinsScreenOptionShowCircle,
    FreewinsScreenOptionShowGizmo,
    FreewinsScreenOptionShowCross,
    FreewinsScreenOptionShowRegion,
    FreewinsScreenOptionNum
} FreewinsScreenOptions;

typedef void (*freewinsScreenOptionChangeNotifyProc) (CompScreen *screen, CompOption *opt, FreewinsScreenOptions num);

CompOption *freewinsGetScreenOption (CompScreen *s, FreewinsScreenOptions num);

typedef enum
{
    SnapModsShift = 0,
    SnapModsAlt = 1,
    SnapModsControl = 2,
    SnapModsMeta = 3,
} FreewinsSnapModsEnum;

typedef enum
{
    InvertModsShift = 0,
    InvertModsAlt = 1,
    InvertModsControl = 2,
    InvertModsMeta = 3,
} FreewinsInvertModsEnum;

typedef enum
{
    ScaleModeToCentre = 0,
    ScaleModeToOppositeCorner = 1,
} FreewinsScaleModeEnum;

typedef enum
{
    ZAxisRotationAlways2d = 0,
    ZAxisRotationAlways3d = 1,
    ZAxisRotationDetermineOnClick = 2,
    ZAxisRotationInterchangable = 3,
    ZAxisRotationSwitch = 4,
    ZAxisRotationTrackball = 5,
} FreewinsZAxisRotationEnum;

typedef enum
{
    RotationAxisAlwaysCentre = 0,
    RotationAxisClickPoint = 1,
    RotationAxisOppositeToClick = 2,
    RotationAxisNearestCorner = 3,
} FreewinsRotationAxisEnum;

#define SnapModsShiftMask (1 << 0)
#define SnapModsAltMask (1 << 1)
#define SnapModsControlMask (1 << 2)
#define SnapModsMetaMask (1 << 3)


#define InvertModsShiftMask (1 << 0)
#define InvertModsAltMask (1 << 1)
#define InvertModsControlMask (1 << 2)
#define InvertModsMetaMask (1 << 3)


CompAction *     freewinsGetRotate (CompDisplay *d);
void             freewinsSetRotateInitiate (CompDisplay *d, CompActionCallBackProc init);
void             freewinsSetRotateTerminate (CompDisplay *d, CompActionCallBackProc term);
CompOption *     freewinsGetRotateOption (CompDisplay *d);
void             freewinsSetRotateNotify (CompDisplay *d, freewinsDisplayOptionChangeNotifyProc notify);

CompAction *     freewinsGetIncrementRotate (CompDisplay *d);
void             freewinsSetIncrementRotateInitiate (CompDisplay *d, CompActionCallBackProc init);
void             freewinsSetIncrementRotateTerminate (CompDisplay *d, CompActionCallBackProc term);
CompOption *     freewinsGetIncrementRotateOption (CompDisplay *d);
void             freewinsSetIncrementRotateNotify (CompDisplay *d, freewinsDisplayOptionChangeNotifyProc notify);

CompAction *     freewinsGetScale (CompDisplay *d);
void             freewinsSetScaleInitiate (CompDisplay *d, CompActionCallBackProc init);
void             freewinsSetScaleTerminate (CompDisplay *d, CompActionCallBackProc term);
CompOption *     freewinsGetScaleOption (CompDisplay *d);
void             freewinsSetScaleNotify (CompDisplay *d, freewinsDisplayOptionChangeNotifyProc notify);

CompAction *     freewinsGetInitiateRotationButton (CompDisplay *d);
void             freewinsSetInitiateRotationButtonInitiate (CompDisplay *d, CompActionCallBackProc init);
void             freewinsSetInitiateRotationButtonTerminate (CompDisplay *d, CompActionCallBackProc term);
CompOption *     freewinsGetInitiateRotationButtonOption (CompDisplay *d);
void             freewinsSetInitiateRotationButtonNotify (CompDisplay *d, freewinsDisplayOptionChangeNotifyProc notify);

CompAction *     freewinsGetInitiateScaleButton (CompDisplay *d);
void             freewinsSetInitiateScaleButtonInitiate (CompDisplay *d, CompActionCallBackProc init);
void             freewinsSetInitiateScaleButtonTerminate (CompDisplay *d, CompActionCallBackProc term);
CompOption *     freewinsGetInitiateScaleButtonOption (CompDisplay *d);
void             freewinsSetInitiateScaleButtonNotify (CompDisplay *d, freewinsDisplayOptionChangeNotifyProc notify);

CompAction *     freewinsGetResetButton (CompDisplay *d);
void             freewinsSetResetButtonInitiate (CompDisplay *d, CompActionCallBackProc init);
void             freewinsSetResetButtonTerminate (CompDisplay *d, CompActionCallBackProc term);
CompOption *     freewinsGetResetButtonOption (CompDisplay *d);
void             freewinsSetResetButtonNotify (CompDisplay *d, freewinsDisplayOptionChangeNotifyProc notify);

CompAction *     freewinsGetResetKey (CompDisplay *d);
void             freewinsSetResetKeyInitiate (CompDisplay *d, CompActionCallBackProc init);
void             freewinsSetResetKeyTerminate (CompDisplay *d, CompActionCallBackProc term);
CompOption *     freewinsGetResetKeyOption (CompDisplay *d);
void             freewinsSetResetKeyNotify (CompDisplay *d, freewinsDisplayOptionChangeNotifyProc notify);

CompAction *     freewinsGetToggleAxisKey (CompDisplay *d);
void             freewinsSetToggleAxisKeyInitiate (CompDisplay *d, CompActionCallBackProc init);
void             freewinsSetToggleAxisKeyTerminate (CompDisplay *d, CompActionCallBackProc term);
CompOption *     freewinsGetToggleAxisKeyOption (CompDisplay *d);
void             freewinsSetToggleAxisKeyNotify (CompDisplay *d, freewinsDisplayOptionChangeNotifyProc notify);

CompListValue *  freewinsGetSnapMods (CompDisplay *d);
unsigned int     freewinsGetSnapModsMask (CompDisplay *d);
CompOption *     freewinsGetSnapModsOption (CompDisplay *d);
void             freewinsSetSnapModsNotify (CompDisplay *d, freewinsDisplayOptionChangeNotifyProc notify);

CompListValue *  freewinsGetInvertMods (CompDisplay *d);
unsigned int     freewinsGetInvertModsMask (CompDisplay *d);
CompOption *     freewinsGetInvertModsOption (CompDisplay *d);
void             freewinsSetInvertModsNotify (CompDisplay *d, freewinsDisplayOptionChangeNotifyProc notify);

CompAction *     freewinsGetScaleUpButton (CompDisplay *d);
void             freewinsSetScaleUpButtonInitiate (CompDisplay *d, CompActionCallBackProc init);
void             freewinsSetScaleUpButtonTerminate (CompDisplay *d, CompActionCallBackProc term);
CompOption *     freewinsGetScaleUpButtonOption (CompDisplay *d);
void             freewinsSetScaleUpButtonNotify (CompDisplay *d, freewinsDisplayOptionChangeNotifyProc notify);

CompAction *     freewinsGetScaleDownButton (CompDisplay *d);
void             freewinsSetScaleDownButtonInitiate (CompDisplay *d, CompActionCallBackProc init);
void             freewinsSetScaleDownButtonTerminate (CompDisplay *d, CompActionCallBackProc term);
CompOption *     freewinsGetScaleDownButtonOption (CompDisplay *d);
void             freewinsSetScaleDownButtonNotify (CompDisplay *d, freewinsDisplayOptionChangeNotifyProc notify);

CompAction *     freewinsGetScaleUpKey (CompDisplay *d);
void             freewinsSetScaleUpKeyInitiate (CompDisplay *d, CompActionCallBackProc init);
void             freewinsSetScaleUpKeyTerminate (CompDisplay *d, CompActionCallBackProc term);
CompOption *     freewinsGetScaleUpKeyOption (CompDisplay *d);
void             freewinsSetScaleUpKeyNotify (CompDisplay *d, freewinsDisplayOptionChangeNotifyProc notify);

CompAction *     freewinsGetScaleDownKey (CompDisplay *d);
void             freewinsSetScaleDownKeyInitiate (CompDisplay *d, CompActionCallBackProc init);
void             freewinsSetScaleDownKeyTerminate (CompDisplay *d, CompActionCallBackProc term);
CompOption *     freewinsGetScaleDownKeyOption (CompDisplay *d);
void             freewinsSetScaleDownKeyNotify (CompDisplay *d, freewinsDisplayOptionChangeNotifyProc notify);

CompAction *     freewinsGetRotateUpKey (CompDisplay *d);
void             freewinsSetRotateUpKeyInitiate (CompDisplay *d, CompActionCallBackProc init);
void             freewinsSetRotateUpKeyTerminate (CompDisplay *d, CompActionCallBackProc term);
CompOption *     freewinsGetRotateUpKeyOption (CompDisplay *d);
void             freewinsSetRotateUpKeyNotify (CompDisplay *d, freewinsDisplayOptionChangeNotifyProc notify);

CompAction *     freewinsGetRotateDownKey (CompDisplay *d);
void             freewinsSetRotateDownKeyInitiate (CompDisplay *d, CompActionCallBackProc init);
void             freewinsSetRotateDownKeyTerminate (CompDisplay *d, CompActionCallBackProc term);
CompOption *     freewinsGetRotateDownKeyOption (CompDisplay *d);
void             freewinsSetRotateDownKeyNotify (CompDisplay *d, freewinsDisplayOptionChangeNotifyProc notify);

CompAction *     freewinsGetRotateLeftKey (CompDisplay *d);
void             freewinsSetRotateLeftKeyInitiate (CompDisplay *d, CompActionCallBackProc init);
void             freewinsSetRotateLeftKeyTerminate (CompDisplay *d, CompActionCallBackProc term);
CompOption *     freewinsGetRotateLeftKeyOption (CompDisplay *d);
void             freewinsSetRotateLeftKeyNotify (CompDisplay *d, freewinsDisplayOptionChangeNotifyProc notify);

CompAction *     freewinsGetRotateRightKey (CompDisplay *d);
void             freewinsSetRotateRightKeyInitiate (CompDisplay *d, CompActionCallBackProc init);
void             freewinsSetRotateRightKeyTerminate (CompDisplay *d, CompActionCallBackProc term);
CompOption *     freewinsGetRotateRightKeyOption (CompDisplay *d);
void             freewinsSetRotateRightKeyNotify (CompDisplay *d, freewinsDisplayOptionChangeNotifyProc notify);

CompAction *     freewinsGetRotateCKey (CompDisplay *d);
void             freewinsSetRotateCKeyInitiate (CompDisplay *d, CompActionCallBackProc init);
void             freewinsSetRotateCKeyTerminate (CompDisplay *d, CompActionCallBackProc term);
CompOption *     freewinsGetRotateCKeyOption (CompDisplay *d);
void             freewinsSetRotateCKeyNotify (CompDisplay *d, freewinsDisplayOptionChangeNotifyProc notify);

CompAction *     freewinsGetRotateCcKey (CompDisplay *d);
void             freewinsSetRotateCcKeyInitiate (CompDisplay *d, CompActionCallBackProc init);
void             freewinsSetRotateCcKeyTerminate (CompDisplay *d, CompActionCallBackProc term);
CompOption *     freewinsGetRotateCcKeyOption (CompDisplay *d);
void             freewinsSetRotateCcKeyNotify (CompDisplay *d, freewinsDisplayOptionChangeNotifyProc notify);

Bool             freewinsGetSnap (CompScreen *s);
CompOption *     freewinsGetSnapOption (CompScreen *s);
void             freewinsSetSnapNotify (CompScreen *s, freewinsScreenOptionChangeNotifyProc notify);

int              freewinsGetSnapThreshold (CompScreen *s);
CompOption *     freewinsGetSnapThresholdOption (CompScreen *s);
void             freewinsSetSnapThresholdNotify (CompScreen *s, freewinsScreenOptionChangeNotifyProc notify);

float            freewinsGetMouseSensitivity (CompScreen *s);
CompOption *     freewinsGetMouseSensitivityOption (CompScreen *s);
void             freewinsSetMouseSensitivityNotify (CompScreen *s, freewinsScreenOptionChangeNotifyProc notify);

int              freewinsGetScaleMode (CompScreen *s);
CompOption *     freewinsGetScaleModeOption (CompScreen *s);
void             freewinsSetScaleModeNotify (CompScreen *s, freewinsScreenOptionChangeNotifyProc notify);

Bool             freewinsGetAllowNegative (CompScreen *s);
CompOption *     freewinsGetAllowNegativeOption (CompScreen *s);
void             freewinsSetAllowNegativeNotify (CompScreen *s, freewinsScreenOptionChangeNotifyProc notify);

Bool             freewinsGetScaleUniform (CompScreen *s);
CompOption *     freewinsGetScaleUniformOption (CompScreen *s);
void             freewinsSetScaleUniformNotify (CompScreen *s, freewinsScreenOptionChangeNotifyProc notify);

float            freewinsGetMinScale (CompScreen *s);
CompOption *     freewinsGetMinScaleOption (CompScreen *s);
void             freewinsSetMinScaleNotify (CompScreen *s, freewinsScreenOptionChangeNotifyProc notify);

int              freewinsGetZAxisRotation (CompScreen *s);
CompOption *     freewinsGetZAxisRotationOption (CompScreen *s);
void             freewinsSetZAxisRotationNotify (CompScreen *s, freewinsScreenOptionChangeNotifyProc notify);

int              freewinsGetRotationAxis (CompScreen *s);
CompOption *     freewinsGetRotationAxisOption (CompScreen *s);
void             freewinsSetRotationAxisNotify (CompScreen *s, freewinsScreenOptionChangeNotifyProc notify);

float            freewinsGet3dPercent (CompScreen *s);
CompOption *     freewinsGet3dPercentOption (CompScreen *s);
void             freewinsSet3dPercentNotify (CompScreen *s, freewinsScreenOptionChangeNotifyProc notify);

Bool             freewinsGetAutoZoom (CompScreen *s);
CompOption *     freewinsGetAutoZoomOption (CompScreen *s);
void             freewinsSetAutoZoomNotify (CompScreen *s, freewinsScreenOptionChangeNotifyProc notify);

Bool             freewinsGetDisableOnTransformedScreen (CompScreen *s);
CompOption *     freewinsGetDisableOnTransformedScreenOption (CompScreen *s);
void             freewinsSetDisableOnTransformedScreenNotify (CompScreen *s, freewinsScreenOptionChangeNotifyProc notify);

float            freewinsGetSpeed (CompScreen *s);
CompOption *     freewinsGetSpeedOption (CompScreen *s);
void             freewinsSetSpeedNotify (CompScreen *s, freewinsScreenOptionChangeNotifyProc notify);

float            freewinsGetRotateIncrementAmount (CompScreen *s);
CompOption *     freewinsGetRotateIncrementAmountOption (CompScreen *s);
void             freewinsSetRotateIncrementAmountNotify (CompScreen *s, freewinsScreenOptionChangeNotifyProc notify);

float            freewinsGetScaleIncrementAmount (CompScreen *s);
CompOption *     freewinsGetScaleIncrementAmountOption (CompScreen *s);
void             freewinsSetScaleIncrementAmountNotify (CompScreen *s, freewinsScreenOptionChangeNotifyProc notify);

CompMatch *      freewinsGetShapeWindowTypes (CompScreen *s);
CompOption *     freewinsGetShapeWindowTypesOption (CompScreen *s);
void             freewinsSetShapeWindowTypesNotify (CompScreen *s, freewinsScreenOptionChangeNotifyProc notify);

Bool             freewinsGetShapeInput (CompScreen *s);
CompOption *     freewinsGetShapeInputOption (CompScreen *s);
void             freewinsSetShapeInputNotify (CompScreen *s, freewinsScreenOptionChangeNotifyProc notify);

Bool             freewinsGetImmediateMoves (CompScreen *s);
CompOption *     freewinsGetImmediateMovesOption (CompScreen *s);
void             freewinsSetImmediateMovesNotify (CompScreen *s, freewinsScreenOptionChangeNotifyProc notify);

unsigned short * freewinsGetCircleColor (CompScreen *s);
unsigned short   freewinsGetCircleColorRed (CompScreen *s);
unsigned short   freewinsGetCircleColorGreen (CompScreen *s);
unsigned short   freewinsGetCircleColorBlue (CompScreen *s);
unsigned short   freewinsGetCircleColorAlpha (CompScreen *s);
CompOption *     freewinsGetCircleColorOption (CompScreen *s);
void             freewinsSetCircleColorNotify (CompScreen *s, freewinsScreenOptionChangeNotifyProc notify);

unsigned short * freewinsGetLineColor (CompScreen *s);
unsigned short   freewinsGetLineColorRed (CompScreen *s);
unsigned short   freewinsGetLineColorGreen (CompScreen *s);
unsigned short   freewinsGetLineColorBlue (CompScreen *s);
unsigned short   freewinsGetLineColorAlpha (CompScreen *s);
CompOption *     freewinsGetLineColorOption (CompScreen *s);
void             freewinsSetLineColorNotify (CompScreen *s, freewinsScreenOptionChangeNotifyProc notify);

unsigned short * freewinsGetCrossLineColor (CompScreen *s);
unsigned short   freewinsGetCrossLineColorRed (CompScreen *s);
unsigned short   freewinsGetCrossLineColorGreen (CompScreen *s);
unsigned short   freewinsGetCrossLineColorBlue (CompScreen *s);
unsigned short   freewinsGetCrossLineColorAlpha (CompScreen *s);
CompOption *     freewinsGetCrossLineColorOption (CompScreen *s);
void             freewinsSetCrossLineColorNotify (CompScreen *s, freewinsScreenOptionChangeNotifyProc notify);

Bool             freewinsGetShowCircle (CompScreen *s);
CompOption *     freewinsGetShowCircleOption (CompScreen *s);
void             freewinsSetShowCircleNotify (CompScreen *s, freewinsScreenOptionChangeNotifyProc notify);

Bool             freewinsGetShowGizmo (CompScreen *s);
CompOption *     freewinsGetShowGizmoOption (CompScreen *s);
void             freewinsSetShowGizmoNotify (CompScreen *s, freewinsScreenOptionChangeNotifyProc notify);

Bool             freewinsGetShowCross (CompScreen *s);
CompOption *     freewinsGetShowCrossOption (CompScreen *s);
void             freewinsSetShowCrossNotify (CompScreen *s, freewinsScreenOptionChangeNotifyProc notify);

Bool             freewinsGetShowRegion (CompScreen *s);
CompOption *     freewinsGetShowRegionOption (CompScreen *s);
void             freewinsSetShowRegionNotify (CompScreen *s, freewinsScreenOptionChangeNotifyProc notify);

#ifndef GENERIC_PRIVATE_DEFINES
#define GENERIC_PRIVATE_DEFINES

#define GET_PLUGIN_CORE(object, plugin) \
    ((plugin##Core *) (object)->base.privates[plugin##CorePrivateIndex].ptr)
#define PLUGIN_CORE(object, plugin, prefix) \
    plugin##Core * prefix##c = GET_PLUGIN_CORE (object, plugin)

#define GET_PLUGIN_DISPLAY(object, plugin) \
    ((plugin##Display *) \
	(object)->base.privates[plugin##DisplayPrivateIndex].ptr)
#define PLUGIN_DISPLAY(object, plugin, prefix) \
    plugin##Display * prefix##d = GET_PLUGIN_DISPLAY (object, plugin)

#define GET_PLUGIN_SCREEN(object, parent, plugin) \
    ((plugin##Screen *) \
	(object)->base.privates[(parent)->screenPrivateIndex].ptr)
#define PLUGIN_SCREEN(object, plugin, prefix) \
    plugin##Screen * prefix##s = \
	GET_PLUGIN_SCREEN (object, \
	GET_PLUGIN_DISPLAY ((object)->display, plugin), plugin)

#define GET_PLUGIN_WINDOW(object, parent, plugin) \
    ((plugin##Window *) \
	(object)->base.privates[(parent)->windowPrivateIndex].ptr)
#define PLUGIN_WINDOW(object, plugin, prefix) \
    plugin##Window * prefix##w = \
	GET_PLUGIN_WINDOW  (object, \
	GET_PLUGIN_SCREEN  ((object)->screen, \
	GET_PLUGIN_DISPLAY ((object)->screen->display, plugin), plugin), plugin)

#endif

COMPIZ_END_DECLS

#endif
