/*
 * This file is autogenerated with bcop:
 * The Compiz option code generator
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 */

#ifndef _SMARTPUT_OPTIONS_H
#define _SMARTPUT_OPTIONS_H

#include <compiz-common.h>

COMPIZ_BEGIN_DECLS

CompPluginVTable * getCompPluginInfo (void);

typedef enum
{
    SmartputDisplayOptionTriggerKey,
    SmartputDisplayOptionTriggerButton,
    SmartputDisplayOptionTriggerAllButton,
    SmartputDisplayOptionUndoKey,
    SmartputDisplayOptionUseTriggerkeyForundo,
    SmartputDisplayOptionAllowWindowsStack,
    SmartputDisplayOptionAllowWindowsShrink,
    SmartputDisplayOptionWindowMinheight,
    SmartputDisplayOptionWindowMinwidth,
    SmartputDisplayOptionWindowMargin,
    SmartputDisplayOptionNum
} SmartputDisplayOptions;

typedef void (*smartputDisplayOptionChangeNotifyProc) (CompDisplay *display, CompOption *opt, SmartputDisplayOptions num);

CompOption *smartputGetDisplayOption (CompDisplay *d, SmartputDisplayOptions num);

typedef enum
{
    SmartputScreenOptionNum
} SmartputScreenOptions;

typedef void (*smartputScreenOptionChangeNotifyProc) (CompScreen *screen, CompOption *opt, SmartputScreenOptions num);

CompOption *smartputGetScreenOption (CompScreen *s, SmartputScreenOptions num);

CompAction *     smartputGetTriggerKey (CompDisplay *d);
void             smartputSetTriggerKeyInitiate (CompDisplay *d, CompActionCallBackProc init);
void             smartputSetTriggerKeyTerminate (CompDisplay *d, CompActionCallBackProc term);
CompOption *     smartputGetTriggerKeyOption (CompDisplay *d);
void             smartputSetTriggerKeyNotify (CompDisplay *d, smartputDisplayOptionChangeNotifyProc notify);

CompAction *     smartputGetTriggerButton (CompDisplay *d);
void             smartputSetTriggerButtonInitiate (CompDisplay *d, CompActionCallBackProc init);
void             smartputSetTriggerButtonTerminate (CompDisplay *d, CompActionCallBackProc term);
CompOption *     smartputGetTriggerButtonOption (CompDisplay *d);
void             smartputSetTriggerButtonNotify (CompDisplay *d, smartputDisplayOptionChangeNotifyProc notify);

CompAction *     smartputGetTriggerAllButton (CompDisplay *d);
void             smartputSetTriggerAllButtonInitiate (CompDisplay *d, CompActionCallBackProc init);
void             smartputSetTriggerAllButtonTerminate (CompDisplay *d, CompActionCallBackProc term);
CompOption *     smartputGetTriggerAllButtonOption (CompDisplay *d);
void             smartputSetTriggerAllButtonNotify (CompDisplay *d, smartputDisplayOptionChangeNotifyProc notify);

CompAction *     smartputGetUndoKey (CompDisplay *d);
void             smartputSetUndoKeyInitiate (CompDisplay *d, CompActionCallBackProc init);
void             smartputSetUndoKeyTerminate (CompDisplay *d, CompActionCallBackProc term);
CompOption *     smartputGetUndoKeyOption (CompDisplay *d);
void             smartputSetUndoKeyNotify (CompDisplay *d, smartputDisplayOptionChangeNotifyProc notify);

Bool             smartputGetUseTriggerkeyForundo (CompDisplay *d);
CompOption *     smartputGetUseTriggerkeyForundoOption (CompDisplay *d);
void             smartputSetUseTriggerkeyForundoNotify (CompDisplay *d, smartputDisplayOptionChangeNotifyProc notify);

Bool             smartputGetAllowWindowsStack (CompDisplay *d);
CompOption *     smartputGetAllowWindowsStackOption (CompDisplay *d);
void             smartputSetAllowWindowsStackNotify (CompDisplay *d, smartputDisplayOptionChangeNotifyProc notify);

Bool             smartputGetAllowWindowsShrink (CompDisplay *d);
CompOption *     smartputGetAllowWindowsShrinkOption (CompDisplay *d);
void             smartputSetAllowWindowsShrinkNotify (CompDisplay *d, smartputDisplayOptionChangeNotifyProc notify);

int              smartputGetWindowMinheight (CompDisplay *d);
CompOption *     smartputGetWindowMinheightOption (CompDisplay *d);
void             smartputSetWindowMinheightNotify (CompDisplay *d, smartputDisplayOptionChangeNotifyProc notify);

int              smartputGetWindowMinwidth (CompDisplay *d);
CompOption *     smartputGetWindowMinwidthOption (CompDisplay *d);
void             smartputSetWindowMinwidthNotify (CompDisplay *d, smartputDisplayOptionChangeNotifyProc notify);

int              smartputGetWindowMargin (CompDisplay *d);
CompOption *     smartputGetWindowMarginOption (CompDisplay *d);
void             smartputSetWindowMarginNotify (CompDisplay *d, smartputDisplayOptionChangeNotifyProc notify);

#ifndef GENERIC_PRIVATE_DEFINES
#define GENERIC_PRIVATE_DEFINES

#define GET_PLUGIN_CORE(object, plugin) \
    ((plugin##Core *) (object)->base.privates[plugin##CorePrivateIndex].ptr)
#define PLUGIN_CORE(object, plugin, prefix) \
    plugin##Core * prefix##c = GET_PLUGIN_CORE (object, plugin)

#define GET_PLUGIN_DISPLAY(object, plugin) \
    ((plugin##Display *) \
	(object)->base.privates[plugin##DisplayPrivateIndex].ptr)
#define PLUGIN_DISPLAY(object, plugin, prefix) \
    plugin##Display * prefix##d = GET_PLUGIN_DISPLAY (object, plugin)

#define GET_PLUGIN_SCREEN(object, parent, plugin) \
    ((plugin##Screen *) \
	(object)->base.privates[(parent)->screenPrivateIndex].ptr)
#define PLUGIN_SCREEN(object, plugin, prefix) \
    plugin##Screen * prefix##s = \
	GET_PLUGIN_SCREEN (object, \
	GET_PLUGIN_DISPLAY ((object)->display, plugin), plugin)

#define GET_PLUGIN_WINDOW(object, parent, plugin) \
    ((plugin##Window *) \
	(object)->base.privates[(parent)->windowPrivateIndex].ptr)
#define PLUGIN_WINDOW(object, plugin, prefix) \
    plugin##Window * prefix##w = \
	GET_PLUGIN_WINDOW  (object, \
	GET_PLUGIN_SCREEN  ((object)->screen, \
	GET_PLUGIN_DISPLAY ((object)->screen->display, plugin), plugin), plugin)

#endif

COMPIZ_END_DECLS

#endif
