/*
 * This file is autogenerated with bcop:
 * The Compiz option code generator
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 */

#ifndef _STAR_OPTIONS_H
#define _STAR_OPTIONS_H

#include <compiz-common.h>

COMPIZ_BEGIN_DECLS

CompPluginVTable * getCompPluginInfo (void);

typedef enum
{
    StarDisplayOptionNumSnowflakes,
    StarDisplayOptionSnowSize,
    StarDisplayOptionSnowSpeed,
    StarDisplayOptionSnowUpdateDelay,
    StarDisplayOptionScreenBoxing,
    StarDisplayOptionScreenDepth,
    StarDisplayOptionStarOffsetX,
    StarDisplayOptionStarOffsetY,
    StarDisplayOptionSnowOverWindows,
    StarDisplayOptionSnowRotation,
    StarDisplayOptionSnowDirection,
    StarDisplayOptionDefaultEnabled,
    StarDisplayOptionSnowTextures,
    StarDisplayOptionUseBlending,
    StarDisplayOptionUseTextures,
    StarDisplayOptionToggleKey,
    StarDisplayOptionNum
} StarDisplayOptions;

typedef void (*starDisplayOptionChangeNotifyProc) (CompDisplay *display, CompOption *opt, StarDisplayOptions num);

CompOption *starGetDisplayOption (CompDisplay *d, StarDisplayOptions num);

typedef enum
{
    StarScreenOptionNum
} StarScreenOptions;

typedef void (*starScreenOptionChangeNotifyProc) (CompScreen *screen, CompOption *opt, StarScreenOptions num);

CompOption *starGetScreenOption (CompScreen *s, StarScreenOptions num);

typedef enum
{
    SnowDirectionTopToBottom = 0,
    SnowDirectionBottomToTop = 1,
    SnowDirectionRightToLeft = 2,
    SnowDirectionLeftToRight = 3,
} StarSnowDirectionEnum;

int              starGetNumSnowflakes (CompDisplay *d);
CompOption *     starGetNumSnowflakesOption (CompDisplay *d);
void             starSetNumSnowflakesNotify (CompDisplay *d, starDisplayOptionChangeNotifyProc notify);

float            starGetSnowSize (CompDisplay *d);
CompOption *     starGetSnowSizeOption (CompDisplay *d);
void             starSetSnowSizeNotify (CompDisplay *d, starDisplayOptionChangeNotifyProc notify);

int              starGetSnowSpeed (CompDisplay *d);
CompOption *     starGetSnowSpeedOption (CompDisplay *d);
void             starSetSnowSpeedNotify (CompDisplay *d, starDisplayOptionChangeNotifyProc notify);

int              starGetSnowUpdateDelay (CompDisplay *d);
CompOption *     starGetSnowUpdateDelayOption (CompDisplay *d);
void             starSetSnowUpdateDelayNotify (CompDisplay *d, starDisplayOptionChangeNotifyProc notify);

int              starGetScreenBoxing (CompDisplay *d);
CompOption *     starGetScreenBoxingOption (CompDisplay *d);
void             starSetScreenBoxingNotify (CompDisplay *d, starDisplayOptionChangeNotifyProc notify);

int              starGetScreenDepth (CompDisplay *d);
CompOption *     starGetScreenDepthOption (CompDisplay *d);
void             starSetScreenDepthNotify (CompDisplay *d, starDisplayOptionChangeNotifyProc notify);

int              starGetStarOffsetX (CompDisplay *d);
CompOption *     starGetStarOffsetXOption (CompDisplay *d);
void             starSetStarOffsetXNotify (CompDisplay *d, starDisplayOptionChangeNotifyProc notify);

int              starGetStarOffsetY (CompDisplay *d);
CompOption *     starGetStarOffsetYOption (CompDisplay *d);
void             starSetStarOffsetYNotify (CompDisplay *d, starDisplayOptionChangeNotifyProc notify);

Bool             starGetSnowOverWindows (CompDisplay *d);
CompOption *     starGetSnowOverWindowsOption (CompDisplay *d);
void             starSetSnowOverWindowsNotify (CompDisplay *d, starDisplayOptionChangeNotifyProc notify);

Bool             starGetSnowRotation (CompDisplay *d);
CompOption *     starGetSnowRotationOption (CompDisplay *d);
void             starSetSnowRotationNotify (CompDisplay *d, starDisplayOptionChangeNotifyProc notify);

int              starGetSnowDirection (CompDisplay *d);
CompOption *     starGetSnowDirectionOption (CompDisplay *d);
void             starSetSnowDirectionNotify (CompDisplay *d, starDisplayOptionChangeNotifyProc notify);

Bool             starGetDefaultEnabled (CompDisplay *d);
CompOption *     starGetDefaultEnabledOption (CompDisplay *d);
void             starSetDefaultEnabledNotify (CompDisplay *d, starDisplayOptionChangeNotifyProc notify);

CompListValue *  starGetSnowTextures (CompDisplay *d);
CompOption *     starGetSnowTexturesOption (CompDisplay *d);
void             starSetSnowTexturesNotify (CompDisplay *d, starDisplayOptionChangeNotifyProc notify);

Bool             starGetUseBlending (CompDisplay *d);
CompOption *     starGetUseBlendingOption (CompDisplay *d);
void             starSetUseBlendingNotify (CompDisplay *d, starDisplayOptionChangeNotifyProc notify);

Bool             starGetUseTextures (CompDisplay *d);
CompOption *     starGetUseTexturesOption (CompDisplay *d);
void             starSetUseTexturesNotify (CompDisplay *d, starDisplayOptionChangeNotifyProc notify);

CompAction *     starGetToggleKey (CompDisplay *d);
void             starSetToggleKeyInitiate (CompDisplay *d, CompActionCallBackProc init);
void             starSetToggleKeyTerminate (CompDisplay *d, CompActionCallBackProc term);
CompOption *     starGetToggleKeyOption (CompDisplay *d);
void             starSetToggleKeyNotify (CompDisplay *d, starDisplayOptionChangeNotifyProc notify);

#ifndef GENERIC_PRIVATE_DEFINES
#define GENERIC_PRIVATE_DEFINES

#define GET_PLUGIN_CORE(object, plugin) \
    ((plugin##Core *) (object)->base.privates[plugin##CorePrivateIndex].ptr)
#define PLUGIN_CORE(object, plugin, prefix) \
    plugin##Core * prefix##c = GET_PLUGIN_CORE (object, plugin)

#define GET_PLUGIN_DISPLAY(object, plugin) \
    ((plugin##Display *) \
	(object)->base.privates[plugin##DisplayPrivateIndex].ptr)
#define PLUGIN_DISPLAY(object, plugin, prefix) \
    plugin##Display * prefix##d = GET_PLUGIN_DISPLAY (object, plugin)

#define GET_PLUGIN_SCREEN(object, parent, plugin) \
    ((plugin##Screen *) \
	(object)->base.privates[(parent)->screenPrivateIndex].ptr)
#define PLUGIN_SCREEN(object, plugin, prefix) \
    plugin##Screen * prefix##s = \
	GET_PLUGIN_SCREEN (object, \
	GET_PLUGIN_DISPLAY ((object)->display, plugin), plugin)

#define GET_PLUGIN_WINDOW(object, parent, plugin) \
    ((plugin##Window *) \
	(object)->base.privates[(parent)->windowPrivateIndex].ptr)
#define PLUGIN_WINDOW(object, plugin, prefix) \
    plugin##Window * prefix##w = \
	GET_PLUGIN_WINDOW  (object, \
	GET_PLUGIN_SCREEN  ((object)->screen, \
	GET_PLUGIN_DISPLAY ((object)->screen->display, plugin), plugin), plugin)

#endif

COMPIZ_END_DECLS

#endif
