/*
 * This file is autogenerated with bcop:
 * The Compiz option code generator
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <compiz-core.h>

#include "static_options.h"

static int StaticOptionsDisplayPrivateIndex;

static CompMetadata staticOptionsMetadata;

static CompPluginVTable *staticPluginVTable = NULL;
CompPluginVTable staticOptionsVTable;

#define STATIC_OPTIONS_DISPLAY(d) PLUGIN_DISPLAY(d, StaticOptions, o)
#define STATIC_OPTIONS_SCREEN(s) PLUGIN_SCREEN(s, StaticOptions, o)

typedef struct _StaticOptionsDisplay
{
    int screenPrivateIndex;

} StaticOptionsDisplay;

typedef struct _StaticOptionsScreen
{
    CompOption opt[StaticScreenOptionNum];
    staticScreenOptionChangeNotifyProc notify[StaticScreenOptionNum];
} StaticOptionsScreen;

CompMatch * staticGetWindowMatch (CompScreen *s)
{
    STATIC_OPTIONS_SCREEN(s);
    return &os->opt[StaticScreenOptionWindowMatch].value.match;
}

CompOption * staticGetWindowMatchOption (CompScreen *s)
{
    STATIC_OPTIONS_SCREEN(s);
    return &os->opt[StaticScreenOptionWindowMatch];
}

void staticSetWindowMatchNotify (CompScreen *s, staticScreenOptionChangeNotifyProc notify)
{
    STATIC_OPTIONS_SCREEN(s);
    os->notify[StaticScreenOptionWindowMatch] = notify;
}

CompOption * staticGetScreenOption (CompScreen *s, StaticScreenOptions num)
{
    STATIC_OPTIONS_SCREEN(s);
    return &os->opt[num];
}

static const CompMetadataOptionInfo staticOptionsScreenOptionInfo[] = {
    { "window_match", "match", 0, 0, 0 },
};

static Bool staticOptionsSetScreenOption (CompPlugin *plugin, CompScreen *s, const char *name, CompOptionValue *value)
{
    STATIC_OPTIONS_SCREEN(s);
    CompOption *o;
    int        index;

    o = compFindOption (os->opt, StaticScreenOptionNum, name, &index);

    if (!o)
        return FALSE;

    switch (index)
    {
     case StaticScreenOptionWindowMatch:
        if (compSetScreenOption (s, o, value))
        {
            if (os->notify[StaticScreenOptionWindowMatch])
                (*os->notify[StaticScreenOptionWindowMatch]) (s, o, StaticScreenOptionWindowMatch);
            return TRUE;
        }
        break;
    default:
        break;
    }
    return FALSE;
}

static CompOption * staticOptionsGetScreenOptions (CompPlugin *plugin, CompScreen *s, int *count)
{
    STATIC_OPTIONS_SCREEN(s);
    if (!os)
    {
        *count = 0;
        return NULL;
    }
    *count = StaticScreenOptionNum;
    return os->opt;
}

static Bool staticOptionsInitScreen (CompPlugin *p, CompScreen *s)
{
    StaticOptionsScreen *os;
    
    STATIC_OPTIONS_DISPLAY (s->display);

    os = calloc (1, sizeof(StaticOptionsScreen));
    if (!os)
        return FALSE;

    s->base.privates[od->screenPrivateIndex].ptr = os;

    if (!compInitScreenOptionsFromMetadata (s, &staticOptionsMetadata, staticOptionsScreenOptionInfo, os->opt, StaticScreenOptionNum))
    {
        free (os);
        return FALSE;
    }

    return TRUE;
}

static void staticOptionsFiniScreen (CompPlugin *p, CompScreen *s)
{
    STATIC_OPTIONS_SCREEN (s);
    STATIC_OPTIONS_DISPLAY (s->display);


    compFiniScreenOptions (s, os->opt, StaticScreenOptionNum);

    free (os);
    s->base.privates[od->screenPrivateIndex].ptr = NULL;
}

static Bool staticOptionsInitDisplay (CompPlugin *p, CompDisplay *d)
{
    StaticOptionsDisplay *od;
   
    
    od = calloc (1, sizeof(StaticOptionsDisplay));
    if (!od)
        return FALSE;

    od->screenPrivateIndex = allocateScreenPrivateIndex(d);
    if (od->screenPrivateIndex < 0)
    {
        free(od);
        return FALSE;
    }

    d->base.privates[StaticOptionsDisplayPrivateIndex].ptr = od;

    
    return TRUE;
}

static void staticOptionsFiniDisplay (CompPlugin *p, CompDisplay *d)
{
    STATIC_OPTIONS_DISPLAY (d);

    freeScreenPrivateIndex(d, od->screenPrivateIndex);
    free (od);
    d->base.privates[StaticOptionsDisplayPrivateIndex].ptr = NULL;
}

static Bool staticOptionsInit (CompPlugin *p)
{
    StaticOptionsDisplayPrivateIndex = allocateDisplayPrivateIndex();
    if (StaticOptionsDisplayPrivateIndex < 0)
        return FALSE;

    if (!compInitPluginMetadataFromInfo (&staticOptionsMetadata, "static",0, 0, staticOptionsScreenOptionInfo, StaticScreenOptionNum))
        return FALSE;

    compAddMetadataFromFile (&staticOptionsMetadata, "static");
    if (staticPluginVTable && staticPluginVTable->init)
        return staticPluginVTable->init (p);
    return TRUE;
}

static void staticOptionsFini (CompPlugin *p)
{
    if (staticPluginVTable && staticPluginVTable->fini)
        staticPluginVTable->fini (p);

    if (StaticOptionsDisplayPrivateIndex >= 0)
        freeDisplayPrivateIndex (StaticOptionsDisplayPrivateIndex);

    compFiniMetadata (&staticOptionsMetadata);
}

static CompBool staticOptionsInitObject (CompPlugin *p, CompObject *o)
{
    static InitPluginObjectProc dispTab[] = {
        (InitPluginObjectProc) 0,
        (InitPluginObjectProc) staticOptionsInitDisplay,
        (InitPluginObjectProc) staticOptionsInitScreen
    };

    RETURN_DISPATCH (o, dispTab, ARRAY_SIZE (dispTab), TRUE, (p, o));
}

static void staticOptionsFiniObject (CompPlugin *p, CompObject *o)
{
    static FiniPluginObjectProc dispTab[] = {
        (FiniPluginObjectProc) 0,
        (FiniPluginObjectProc) staticOptionsFiniDisplay,
        (FiniPluginObjectProc) staticOptionsFiniScreen
    };

    DISPATCH (o, dispTab, ARRAY_SIZE (dispTab), (p, o));
}

static CompBool staticOptionsInitObjectWrapper (CompPlugin *p, CompObject *o)
{
    CompBool rv = TRUE;
    rv = staticOptionsInitObject (p, o);
    if (staticPluginVTable->initObject)
        rv &= staticPluginVTable->initObject (p, o);
    return rv;
}

static void staticOptionsFiniObjectWrapper (CompPlugin *p, CompObject *o)
{
    if (staticPluginVTable->finiObject)
        staticPluginVTable->finiObject (p, o);
    staticOptionsFiniObject (p, o);
}

static CompOption * staticOptionsGetObjectOptions (CompPlugin *p, CompObject *o, int *count)
{
    static GetPluginObjectOptionsProc dispTab[] = {
        (GetPluginObjectOptionsProc) 0,
            (GetPluginObjectOptionsProc) 0,
        (GetPluginObjectOptionsProc) staticOptionsGetScreenOptions
    };

    *count = 0;
    RETURN_DISPATCH (o, dispTab, ARRAY_SIZE (dispTab),
		     NULL, (p, o, count));
}

static CompBool staticOptionsSetObjectOption (CompPlugin *p, CompObject *o, const char *name, CompOptionValue *value)
{
    static SetPluginObjectOptionProc dispTab[] = {
        (SetPluginObjectOptionProc) 0,
        (SetPluginObjectOptionProc) 0,
        (SetPluginObjectOptionProc) staticOptionsSetScreenOption
    };

    RETURN_DISPATCH (o, dispTab, ARRAY_SIZE (dispTab), FALSE,
		     (p, o, name, value));
}

static CompMetadata *
staticOptionsGetMetadata (CompPlugin *plugin)
{
    return &staticOptionsMetadata;
}

CompPluginVTable *getCompPluginInfo20070830 (void)
{
    if (!staticPluginVTable)
    {
        staticPluginVTable = getCompPluginInfo ();
        memcpy(&staticOptionsVTable, staticPluginVTable, sizeof(CompPluginVTable));
        staticOptionsVTable.getMetadata = staticOptionsGetMetadata;
        staticOptionsVTable.init = staticOptionsInit;
        staticOptionsVTable.fini = staticOptionsFini;
        staticOptionsVTable.initObject = staticOptionsInitObjectWrapper;
        staticOptionsVTable.finiObject = staticOptionsFiniObjectWrapper;
        staticOptionsVTable.getObjectOptions = staticOptionsGetObjectOptions;
	staticOptionsVTable.setObjectOption = staticOptionsSetObjectOption;
	
    }
    return &staticOptionsVTable;
}

