/*
 * This file is autogenerated with bcop:
 * The Compiz option code generator
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <compiz-core.h>

#include "throw_options.h"

static int ThrowOptionsDisplayPrivateIndex;

static CompMetadata throwOptionsMetadata;

static CompPluginVTable *throwPluginVTable = NULL;
CompPluginVTable throwOptionsVTable;

#define THROW_OPTIONS_DISPLAY(d) PLUGIN_DISPLAY(d, ThrowOptions, o)
#define THROW_OPTIONS_SCREEN(s) PLUGIN_SCREEN(s, ThrowOptions, o)

typedef struct _ThrowOptionsDisplay
{
    int screenPrivateIndex;

} ThrowOptionsDisplay;

typedef struct _ThrowOptionsScreen
{
    CompOption opt[ThrowScreenOptionNum];
    throwScreenOptionChangeNotifyProc notify[ThrowScreenOptionNum];
} ThrowOptionsScreen;

float throwGetVelocityX (CompScreen *s)
{
    THROW_OPTIONS_SCREEN(s);
    return os->opt[ThrowScreenOptionVelocityX].value.f;
}

CompOption * throwGetVelocityXOption (CompScreen *s)
{
    THROW_OPTIONS_SCREEN(s);
    return &os->opt[ThrowScreenOptionVelocityX];
}

void throwSetVelocityXNotify (CompScreen *s, throwScreenOptionChangeNotifyProc notify)
{
    THROW_OPTIONS_SCREEN(s);
    os->notify[ThrowScreenOptionVelocityX] = notify;
}

float throwGetVelocityY (CompScreen *s)
{
    THROW_OPTIONS_SCREEN(s);
    return os->opt[ThrowScreenOptionVelocityY].value.f;
}

CompOption * throwGetVelocityYOption (CompScreen *s)
{
    THROW_OPTIONS_SCREEN(s);
    return &os->opt[ThrowScreenOptionVelocityY];
}

void throwSetVelocityYNotify (CompScreen *s, throwScreenOptionChangeNotifyProc notify)
{
    THROW_OPTIONS_SCREEN(s);
    os->notify[ThrowScreenOptionVelocityY] = notify;
}

float throwGetFrictionConstant (CompScreen *s)
{
    THROW_OPTIONS_SCREEN(s);
    return os->opt[ThrowScreenOptionFrictionConstant].value.f;
}

CompOption * throwGetFrictionConstantOption (CompScreen *s)
{
    THROW_OPTIONS_SCREEN(s);
    return &os->opt[ThrowScreenOptionFrictionConstant];
}

void throwSetFrictionConstantNotify (CompScreen *s, throwScreenOptionChangeNotifyProc notify)
{
    THROW_OPTIONS_SCREEN(s);
    os->notify[ThrowScreenOptionFrictionConstant] = notify;
}

Bool throwGetConstrainX (CompScreen *s)
{
    THROW_OPTIONS_SCREEN(s);
    return os->opt[ThrowScreenOptionConstrainX].value.b;
}

CompOption * throwGetConstrainXOption (CompScreen *s)
{
    THROW_OPTIONS_SCREEN(s);
    return &os->opt[ThrowScreenOptionConstrainX];
}

void throwSetConstrainXNotify (CompScreen *s, throwScreenOptionChangeNotifyProc notify)
{
    THROW_OPTIONS_SCREEN(s);
    os->notify[ThrowScreenOptionConstrainX] = notify;
}

Bool throwGetConstrainY (CompScreen *s)
{
    THROW_OPTIONS_SCREEN(s);
    return os->opt[ThrowScreenOptionConstrainY].value.b;
}

CompOption * throwGetConstrainYOption (CompScreen *s)
{
    THROW_OPTIONS_SCREEN(s);
    return &os->opt[ThrowScreenOptionConstrainY];
}

void throwSetConstrainYNotify (CompScreen *s, throwScreenOptionChangeNotifyProc notify)
{
    THROW_OPTIONS_SCREEN(s);
    os->notify[ThrowScreenOptionConstrainY] = notify;
}

CompOption * throwGetScreenOption (CompScreen *s, ThrowScreenOptions num)
{
    THROW_OPTIONS_SCREEN(s);
    return &os->opt[num];
}

static const CompMetadataOptionInfo throwOptionsScreenOptionInfo[] = {
    { "velocity_x", "float", "<min>1.0</min><max>100.0</max>", 0, 0 },
    { "velocity_y", "float", "<min>1.0</min><max>100.0</max>", 0, 0 },
    { "friction_constant", "float", "<min>1.0</min><max>100.0</max>", 0, 0 },
    { "constrain_x", "bool", 0, 0, 0 },
    { "constrain_y", "bool", 0, 0, 0 },
};

static Bool throwOptionsSetScreenOption (CompPlugin *plugin, CompScreen *s, const char *name, CompOptionValue *value)
{
    THROW_OPTIONS_SCREEN(s);
    CompOption *o;
    int        index;

    o = compFindOption (os->opt, ThrowScreenOptionNum, name, &index);

    if (!o)
        return FALSE;

    switch (index)
    {
     case ThrowScreenOptionVelocityX:
        if (compSetScreenOption (s, o, value))
        {
            if (os->notify[ThrowScreenOptionVelocityX])
                (*os->notify[ThrowScreenOptionVelocityX]) (s, o, ThrowScreenOptionVelocityX);
            return TRUE;
        }
        break;
     case ThrowScreenOptionVelocityY:
        if (compSetScreenOption (s, o, value))
        {
            if (os->notify[ThrowScreenOptionVelocityY])
                (*os->notify[ThrowScreenOptionVelocityY]) (s, o, ThrowScreenOptionVelocityY);
            return TRUE;
        }
        break;
     case ThrowScreenOptionFrictionConstant:
        if (compSetScreenOption (s, o, value))
        {
            if (os->notify[ThrowScreenOptionFrictionConstant])
                (*os->notify[ThrowScreenOptionFrictionConstant]) (s, o, ThrowScreenOptionFrictionConstant);
            return TRUE;
        }
        break;
     case ThrowScreenOptionConstrainX:
        if (compSetScreenOption (s, o, value))
        {
            if (os->notify[ThrowScreenOptionConstrainX])
                (*os->notify[ThrowScreenOptionConstrainX]) (s, o, ThrowScreenOptionConstrainX);
            return TRUE;
        }
        break;
     case ThrowScreenOptionConstrainY:
        if (compSetScreenOption (s, o, value))
        {
            if (os->notify[ThrowScreenOptionConstrainY])
                (*os->notify[ThrowScreenOptionConstrainY]) (s, o, ThrowScreenOptionConstrainY);
            return TRUE;
        }
        break;
    default:
        break;
    }
    return FALSE;
}

static CompOption * throwOptionsGetScreenOptions (CompPlugin *plugin, CompScreen *s, int *count)
{
    THROW_OPTIONS_SCREEN(s);
    if (!os)
    {
        *count = 0;
        return NULL;
    }
    *count = ThrowScreenOptionNum;
    return os->opt;
}

static Bool throwOptionsInitScreen (CompPlugin *p, CompScreen *s)
{
    ThrowOptionsScreen *os;
    
    THROW_OPTIONS_DISPLAY (s->display);

    os = calloc (1, sizeof(ThrowOptionsScreen));
    if (!os)
        return FALSE;

    s->base.privates[od->screenPrivateIndex].ptr = os;

    if (!compInitScreenOptionsFromMetadata (s, &throwOptionsMetadata, throwOptionsScreenOptionInfo, os->opt, ThrowScreenOptionNum))
    {
        free (os);
        return FALSE;
    }

    return TRUE;
}

static void throwOptionsFiniScreen (CompPlugin *p, CompScreen *s)
{
    THROW_OPTIONS_SCREEN (s);
    THROW_OPTIONS_DISPLAY (s->display);


    compFiniScreenOptions (s, os->opt, ThrowScreenOptionNum);

    free (os);
    s->base.privates[od->screenPrivateIndex].ptr = NULL;
}

static Bool throwOptionsInitDisplay (CompPlugin *p, CompDisplay *d)
{
    ThrowOptionsDisplay *od;
   
    
    od = calloc (1, sizeof(ThrowOptionsDisplay));
    if (!od)
        return FALSE;

    od->screenPrivateIndex = allocateScreenPrivateIndex(d);
    if (od->screenPrivateIndex < 0)
    {
        free(od);
        return FALSE;
    }

    d->base.privates[ThrowOptionsDisplayPrivateIndex].ptr = od;

    
    return TRUE;
}

static void throwOptionsFiniDisplay (CompPlugin *p, CompDisplay *d)
{
    THROW_OPTIONS_DISPLAY (d);

    freeScreenPrivateIndex(d, od->screenPrivateIndex);
    free (od);
    d->base.privates[ThrowOptionsDisplayPrivateIndex].ptr = NULL;
}

static Bool throwOptionsInit (CompPlugin *p)
{
    ThrowOptionsDisplayPrivateIndex = allocateDisplayPrivateIndex();
    if (ThrowOptionsDisplayPrivateIndex < 0)
        return FALSE;

    if (!compInitPluginMetadataFromInfo (&throwOptionsMetadata, "throw",0, 0, throwOptionsScreenOptionInfo, ThrowScreenOptionNum))
        return FALSE;

    compAddMetadataFromFile (&throwOptionsMetadata, "throw");
    if (throwPluginVTable && throwPluginVTable->init)
        return throwPluginVTable->init (p);
    return TRUE;
}

static void throwOptionsFini (CompPlugin *p)
{
    if (throwPluginVTable && throwPluginVTable->fini)
        throwPluginVTable->fini (p);

    if (ThrowOptionsDisplayPrivateIndex >= 0)
        freeDisplayPrivateIndex (ThrowOptionsDisplayPrivateIndex);

    compFiniMetadata (&throwOptionsMetadata);
}

static CompBool throwOptionsInitObject (CompPlugin *p, CompObject *o)
{
    static InitPluginObjectProc dispTab[] = {
        (InitPluginObjectProc) 0,
        (InitPluginObjectProc) throwOptionsInitDisplay,
        (InitPluginObjectProc) throwOptionsInitScreen
    };

    RETURN_DISPATCH (o, dispTab, ARRAY_SIZE (dispTab), TRUE, (p, o));
}

static void throwOptionsFiniObject (CompPlugin *p, CompObject *o)
{
    static FiniPluginObjectProc dispTab[] = {
        (FiniPluginObjectProc) 0,
        (FiniPluginObjectProc) throwOptionsFiniDisplay,
        (FiniPluginObjectProc) throwOptionsFiniScreen
    };

    DISPATCH (o, dispTab, ARRAY_SIZE (dispTab), (p, o));
}

static CompBool throwOptionsInitObjectWrapper (CompPlugin *p, CompObject *o)
{
    CompBool rv = TRUE;
    rv = throwOptionsInitObject (p, o);
    if (throwPluginVTable->initObject)
        rv &= throwPluginVTable->initObject (p, o);
    return rv;
}

static void throwOptionsFiniObjectWrapper (CompPlugin *p, CompObject *o)
{
    if (throwPluginVTable->finiObject)
        throwPluginVTable->finiObject (p, o);
    throwOptionsFiniObject (p, o);
}

static CompOption * throwOptionsGetObjectOptions (CompPlugin *p, CompObject *o, int *count)
{
    static GetPluginObjectOptionsProc dispTab[] = {
        (GetPluginObjectOptionsProc) 0,
            (GetPluginObjectOptionsProc) 0,
        (GetPluginObjectOptionsProc) throwOptionsGetScreenOptions
    };

    *count = 0;
    RETURN_DISPATCH (o, dispTab, ARRAY_SIZE (dispTab),
		     NULL, (p, o, count));
}

static CompBool throwOptionsSetObjectOption (CompPlugin *p, CompObject *o, const char *name, CompOptionValue *value)
{
    static SetPluginObjectOptionProc dispTab[] = {
        (SetPluginObjectOptionProc) 0,
        (SetPluginObjectOptionProc) 0,
        (SetPluginObjectOptionProc) throwOptionsSetScreenOption
    };

    RETURN_DISPATCH (o, dispTab, ARRAY_SIZE (dispTab), FALSE,
		     (p, o, name, value));
}

static CompMetadata *
throwOptionsGetMetadata (CompPlugin *plugin)
{
    return &throwOptionsMetadata;
}

CompPluginVTable *getCompPluginInfo20070830 (void)
{
    if (!throwPluginVTable)
    {
        throwPluginVTable = getCompPluginInfo ();
        memcpy(&throwOptionsVTable, throwPluginVTable, sizeof(CompPluginVTable));
        throwOptionsVTable.getMetadata = throwOptionsGetMetadata;
        throwOptionsVTable.init = throwOptionsInit;
        throwOptionsVTable.fini = throwOptionsFini;
        throwOptionsVTable.initObject = throwOptionsInitObjectWrapper;
        throwOptionsVTable.finiObject = throwOptionsFiniObjectWrapper;
        throwOptionsVTable.getObjectOptions = throwOptionsGetObjectOptions;
	throwOptionsVTable.setObjectOption = throwOptionsSetObjectOption;
	
    }
    return &throwOptionsVTable;
}

