/*
 * This file is autogenerated with bcop:
 * The Compiz option code generator
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <compiz-core.h>

#include "toggledeco_options.h"

static int ToggledecoOptionsDisplayPrivateIndex;

static CompMetadata toggledecoOptionsMetadata;

static CompPluginVTable *toggledecoPluginVTable = NULL;
CompPluginVTable toggledecoOptionsVTable;

#define TOGGLEDECO_OPTIONS_DISPLAY(d) PLUGIN_DISPLAY(d, ToggledecoOptions, o)
#define TOGGLEDECO_OPTIONS_SCREEN(s) PLUGIN_SCREEN(s, ToggledecoOptions, o)

typedef struct _ToggledecoOptionsDisplay
{
    int screenPrivateIndex;

    CompOption opt[ToggledecoDisplayOptionNum];
    toggledecoDisplayOptionChangeNotifyProc notify[ToggledecoDisplayOptionNum];
} ToggledecoOptionsDisplay;

typedef struct _ToggledecoOptionsScreen
{
} ToggledecoOptionsScreen;

CompAction * toggledecoGetTriggerKey (CompDisplay *d)
{
    TOGGLEDECO_OPTIONS_DISPLAY(d);
    return &od->opt[ToggledecoDisplayOptionTriggerKey].value.action;
}

void toggledecoSetTriggerKeyInitiate (CompDisplay *d, CompActionCallBackProc init)
{
    TOGGLEDECO_OPTIONS_DISPLAY(d);
    od->opt[ToggledecoDisplayOptionTriggerKey].value.action.initiate = init;
}

void toggledecoSetTriggerKeyTerminate (CompDisplay *d, CompActionCallBackProc term)
{
    TOGGLEDECO_OPTIONS_DISPLAY(d);
    od->opt[ToggledecoDisplayOptionTriggerKey].value.action.terminate = term;
}

CompOption * toggledecoGetTriggerKeyOption (CompDisplay *d)
{
    TOGGLEDECO_OPTIONS_DISPLAY(d);
    return &od->opt[ToggledecoDisplayOptionTriggerKey];
}

void toggledecoSetTriggerKeyNotify (CompDisplay *d, toggledecoDisplayOptionChangeNotifyProc notify)
{
    TOGGLEDECO_OPTIONS_DISPLAY(d);
    od->notify[ToggledecoDisplayOptionTriggerKey] = notify;
}

CompAction * toggledecoGetTriggerAllKey (CompDisplay *d)
{
    TOGGLEDECO_OPTIONS_DISPLAY(d);
    return &od->opt[ToggledecoDisplayOptionTriggerAllKey].value.action;
}

void toggledecoSetTriggerAllKeyInitiate (CompDisplay *d, CompActionCallBackProc init)
{
    TOGGLEDECO_OPTIONS_DISPLAY(d);
    od->opt[ToggledecoDisplayOptionTriggerAllKey].value.action.initiate = init;
}

void toggledecoSetTriggerAllKeyTerminate (CompDisplay *d, CompActionCallBackProc term)
{
    TOGGLEDECO_OPTIONS_DISPLAY(d);
    od->opt[ToggledecoDisplayOptionTriggerAllKey].value.action.terminate = term;
}

CompOption * toggledecoGetTriggerAllKeyOption (CompDisplay *d)
{
    TOGGLEDECO_OPTIONS_DISPLAY(d);
    return &od->opt[ToggledecoDisplayOptionTriggerAllKey];
}

void toggledecoSetTriggerAllKeyNotify (CompDisplay *d, toggledecoDisplayOptionChangeNotifyProc notify)
{
    TOGGLEDECO_OPTIONS_DISPLAY(d);
    od->notify[ToggledecoDisplayOptionTriggerAllKey] = notify;
}

CompOption * toggledecoGetDisplayOption (CompDisplay *d, ToggledecoDisplayOptions num)
{
    TOGGLEDECO_OPTIONS_DISPLAY(d);
    return &od->opt[num];
}

static const CompMetadataOptionInfo toggledecoOptionsDisplayOptionInfo[] = {
    { "trigger_key", "key", 0, 0, 0 },
    { "trigger_all_key", "key", 0, 0, 0 },
};

static Bool toggledecoOptionsSetDisplayOption (CompPlugin *plugin, CompDisplay *d, const char *name, CompOptionValue *value)
{
    TOGGLEDECO_OPTIONS_DISPLAY(d);
    CompOption *o;
    int        index;

    o = compFindOption (od->opt, ToggledecoDisplayOptionNum, name, &index);

    if (!o)
        return FALSE;

    switch (index)
    {
     case ToggledecoDisplayOptionTriggerKey:
        if (compSetDisplayOption (d, o, value))
        {
            if (od->notify[ToggledecoDisplayOptionTriggerKey])
                (*od->notify[ToggledecoDisplayOptionTriggerKey]) (d, o, ToggledecoDisplayOptionTriggerKey);
            return TRUE;
        }
        break;
     case ToggledecoDisplayOptionTriggerAllKey:
        if (compSetDisplayOption (d, o, value))
        {
            if (od->notify[ToggledecoDisplayOptionTriggerAllKey])
                (*od->notify[ToggledecoDisplayOptionTriggerAllKey]) (d, o, ToggledecoDisplayOptionTriggerAllKey);
            return TRUE;
        }
        break;
    default:
        break;
    }
    return FALSE;
}

static CompOption * toggledecoOptionsGetDisplayOptions (CompPlugin *plugin, CompDisplay *d, int *count)
{
    TOGGLEDECO_OPTIONS_DISPLAY(d);
    if (!od)
    {
        *count = 0;
        return NULL;
    }
    *count = ToggledecoDisplayOptionNum;
    return od->opt;
}

static Bool toggledecoOptionsInitScreen (CompPlugin *p, CompScreen *s)
{
    ToggledecoOptionsScreen *os;
    
    TOGGLEDECO_OPTIONS_DISPLAY (s->display);

    os = calloc (1, sizeof(ToggledecoOptionsScreen));
    if (!os)
        return FALSE;

    s->base.privates[od->screenPrivateIndex].ptr = os;

    
    return TRUE;
}

static void toggledecoOptionsFiniScreen (CompPlugin *p, CompScreen *s)
{
    TOGGLEDECO_OPTIONS_SCREEN (s);
    TOGGLEDECO_OPTIONS_DISPLAY (s->display);

    free (os);
    s->base.privates[od->screenPrivateIndex].ptr = NULL;
}

static Bool toggledecoOptionsInitDisplay (CompPlugin *p, CompDisplay *d)
{
    ToggledecoOptionsDisplay *od;
   
    
    od = calloc (1, sizeof(ToggledecoOptionsDisplay));
    if (!od)
        return FALSE;

    od->screenPrivateIndex = allocateScreenPrivateIndex(d);
    if (od->screenPrivateIndex < 0)
    {
        free(od);
        return FALSE;
    }

    d->base.privates[ToggledecoOptionsDisplayPrivateIndex].ptr = od;

    if (!compInitDisplayOptionsFromMetadata (d, &toggledecoOptionsMetadata, toggledecoOptionsDisplayOptionInfo, od->opt, ToggledecoDisplayOptionNum))
    {
        free (od);
        return FALSE;
    }

    return TRUE;
}

static void toggledecoOptionsFiniDisplay (CompPlugin *p, CompDisplay *d)
{
    TOGGLEDECO_OPTIONS_DISPLAY (d);

    freeScreenPrivateIndex(d, od->screenPrivateIndex);

    compFiniDisplayOptions (d, od->opt, ToggledecoDisplayOptionNum);

    free (od);
    d->base.privates[ToggledecoOptionsDisplayPrivateIndex].ptr = NULL;
}

static Bool toggledecoOptionsInit (CompPlugin *p)
{
    ToggledecoOptionsDisplayPrivateIndex = allocateDisplayPrivateIndex();
    if (ToggledecoOptionsDisplayPrivateIndex < 0)
        return FALSE;

    if (!compInitPluginMetadataFromInfo (&toggledecoOptionsMetadata, "toggledeco",toggledecoOptionsDisplayOptionInfo, ToggledecoDisplayOptionNum, 0, 0))
        return FALSE;

    compAddMetadataFromFile (&toggledecoOptionsMetadata, "toggledeco");
    if (toggledecoPluginVTable && toggledecoPluginVTable->init)
        return toggledecoPluginVTable->init (p);
    return TRUE;
}

static void toggledecoOptionsFini (CompPlugin *p)
{
    if (toggledecoPluginVTable && toggledecoPluginVTable->fini)
        toggledecoPluginVTable->fini (p);

    if (ToggledecoOptionsDisplayPrivateIndex >= 0)
        freeDisplayPrivateIndex (ToggledecoOptionsDisplayPrivateIndex);

    compFiniMetadata (&toggledecoOptionsMetadata);
}

static CompBool toggledecoOptionsInitObject (CompPlugin *p, CompObject *o)
{
    static InitPluginObjectProc dispTab[] = {
        (InitPluginObjectProc) 0,
        (InitPluginObjectProc) toggledecoOptionsInitDisplay,
        (InitPluginObjectProc) toggledecoOptionsInitScreen
    };

    RETURN_DISPATCH (o, dispTab, ARRAY_SIZE (dispTab), TRUE, (p, o));
}

static void toggledecoOptionsFiniObject (CompPlugin *p, CompObject *o)
{
    static FiniPluginObjectProc dispTab[] = {
        (FiniPluginObjectProc) 0,
        (FiniPluginObjectProc) toggledecoOptionsFiniDisplay,
        (FiniPluginObjectProc) toggledecoOptionsFiniScreen
    };

    DISPATCH (o, dispTab, ARRAY_SIZE (dispTab), (p, o));
}

static CompBool toggledecoOptionsInitObjectWrapper (CompPlugin *p, CompObject *o)
{
    CompBool rv = TRUE;
    rv = toggledecoOptionsInitObject (p, o);
    if (toggledecoPluginVTable->initObject)
        rv &= toggledecoPluginVTable->initObject (p, o);
    return rv;
}

static void toggledecoOptionsFiniObjectWrapper (CompPlugin *p, CompObject *o)
{
    if (toggledecoPluginVTable->finiObject)
        toggledecoPluginVTable->finiObject (p, o);
    toggledecoOptionsFiniObject (p, o);
}

static CompOption * toggledecoOptionsGetObjectOptions (CompPlugin *p, CompObject *o, int *count)
{
    static GetPluginObjectOptionsProc dispTab[] = {
        (GetPluginObjectOptionsProc) 0,
            (GetPluginObjectOptionsProc) toggledecoOptionsGetDisplayOptions,
    };

    *count = 0;
    RETURN_DISPATCH (o, dispTab, ARRAY_SIZE (dispTab),
		     NULL, (p, o, count));
}

static CompBool toggledecoOptionsSetObjectOption (CompPlugin *p, CompObject *o, const char *name, CompOptionValue *value)
{
    static SetPluginObjectOptionProc dispTab[] = {
        (SetPluginObjectOptionProc) 0,
        (SetPluginObjectOptionProc) toggledecoOptionsSetDisplayOption,
    };

    RETURN_DISPATCH (o, dispTab, ARRAY_SIZE (dispTab), FALSE,
		     (p, o, name, value));
}

static CompMetadata *
toggledecoOptionsGetMetadata (CompPlugin *plugin)
{
    return &toggledecoOptionsMetadata;
}

CompPluginVTable *getCompPluginInfo20070830 (void)
{
    if (!toggledecoPluginVTable)
    {
        toggledecoPluginVTable = getCompPluginInfo ();
        memcpy(&toggledecoOptionsVTable, toggledecoPluginVTable, sizeof(CompPluginVTable));
        toggledecoOptionsVTable.getMetadata = toggledecoOptionsGetMetadata;
        toggledecoOptionsVTable.init = toggledecoOptionsInit;
        toggledecoOptionsVTable.fini = toggledecoOptionsFini;
        toggledecoOptionsVTable.initObject = toggledecoOptionsInitObjectWrapper;
        toggledecoOptionsVTable.finiObject = toggledecoOptionsFiniObjectWrapper;
        toggledecoOptionsVTable.getObjectOptions = toggledecoOptionsGetObjectOptions;
	toggledecoOptionsVTable.setObjectOption = toggledecoOptionsSetObjectOption;
	
    }
    return &toggledecoOptionsVTable;
}

