/*
 * This file is autogenerated with bcop:
 * The Compiz option code generator
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 */

#ifndef _WIZARD_OPTIONS_H
#define _WIZARD_OPTIONS_H

#include <compiz-common.h>

COMPIZ_BEGIN_DECLS

CompPluginVTable * getCompPluginInfo (void);

typedef enum
{
    WizardDisplayOptionInitiate,
    WizardDisplayOptionDefaultEnabled,
    WizardDisplayOptionNum
} WizardDisplayOptions;

typedef void (*wizardDisplayOptionChangeNotifyProc) (CompDisplay *display, CompOption *opt, WizardDisplayOptions num);

CompOption *wizardGetDisplayOption (CompDisplay *d, WizardDisplayOptions num);

typedef enum
{
    WizardScreenOptionGx,
    WizardScreenOptionGy,
    WizardScreenOptionGStrength,
    WizardScreenOptionGPosx,
    WizardScreenOptionGPosy,
    WizardScreenOptionGSpeed,
    WizardScreenOptionGAngle,
    WizardScreenOptionGMovement,
    WizardScreenOptionEActive,
    WizardScreenOptionEName,
    WizardScreenOptionETrigger,
    WizardScreenOptionEPosx,
    WizardScreenOptionEPosy,
    WizardScreenOptionESpeed,
    WizardScreenOptionEAngle,
    WizardScreenOptionEMovement,
    WizardScreenOptionECount,
    WizardScreenOptionEH,
    WizardScreenOptionEDh,
    WizardScreenOptionEL,
    WizardScreenOptionEDl,
    WizardScreenOptionEA,
    WizardScreenOptionEDa,
    WizardScreenOptionEDx,
    WizardScreenOptionEDy,
    WizardScreenOptionEDcirc,
    WizardScreenOptionEVx,
    WizardScreenOptionEVy,
    WizardScreenOptionEVt,
    WizardScreenOptionEVphi,
    WizardScreenOptionEDvx,
    WizardScreenOptionEDvy,
    WizardScreenOptionEDvcirc,
    WizardScreenOptionEDvt,
    WizardScreenOptionEDvphi,
    WizardScreenOptionES,
    WizardScreenOptionEDs,
    WizardScreenOptionESnew,
    WizardScreenOptionEDsnew,
    WizardScreenOptionEG,
    WizardScreenOptionEDg,
    WizardScreenOptionEGp,
    WizardScreenOptionHardLimit,
    WizardScreenOptionSoftLimit,
    WizardScreenOptionDarken,
    WizardScreenOptionBlend,
    WizardScreenOptionTnew,
    WizardScreenOptionTold,
    WizardScreenOptionNum
} WizardScreenOptions;

typedef void (*wizardScreenOptionChangeNotifyProc) (CompScreen *screen, CompOption *opt, WizardScreenOptions num);

CompOption *wizardGetScreenOption (CompScreen *s, WizardScreenOptions num);

typedef enum
{
    GMovementMousePosition = 0,
    GMovementFollowMouse = 1,
    GMovementBounce = 2,
    GMovementWrap = 3,
} WizardGMovementEnum;

typedef enum
{
    ETriggerPersistent = 0,
    ETriggerMouseMovement = 1,
    ETriggerRandomShot = 2,
    ETriggerRandomPeriod = 3,
} WizardETriggerEnum;

typedef enum
{
    EMovementMousePosition = 0,
    EMovementFollowMouse = 1,
    EMovementBounce = 2,
    EMovementWrap = 3,
} WizardEMovementEnum;

#define GMovementMousePositionMask (1 << 0)
#define GMovementFollowMouseMask (1 << 1)
#define GMovementBounceMask (1 << 2)
#define GMovementWrapMask (1 << 3)


#define ETriggerPersistentMask (1 << 0)
#define ETriggerMouseMovementMask (1 << 1)
#define ETriggerRandomShotMask (1 << 2)
#define ETriggerRandomPeriodMask (1 << 3)


#define EMovementMousePositionMask (1 << 0)
#define EMovementFollowMouseMask (1 << 1)
#define EMovementBounceMask (1 << 2)
#define EMovementWrapMask (1 << 3)


CompAction *     wizardGetInitiate (CompDisplay *d);
void             wizardSetInitiateInitiate (CompDisplay *d, CompActionCallBackProc init);
void             wizardSetInitiateTerminate (CompDisplay *d, CompActionCallBackProc term);
CompOption *     wizardGetInitiateOption (CompDisplay *d);
void             wizardSetInitiateNotify (CompDisplay *d, wizardDisplayOptionChangeNotifyProc notify);

Bool             wizardGetDefaultEnabled (CompDisplay *d);
CompOption *     wizardGetDefaultEnabledOption (CompDisplay *d);
void             wizardSetDefaultEnabledNotify (CompDisplay *d, wizardDisplayOptionChangeNotifyProc notify);

float            wizardGetGx (CompScreen *s);
CompOption *     wizardGetGxOption (CompScreen *s);
void             wizardSetGxNotify (CompScreen *s, wizardScreenOptionChangeNotifyProc notify);

float            wizardGetGy (CompScreen *s);
CompOption *     wizardGetGyOption (CompScreen *s);
void             wizardSetGyNotify (CompScreen *s, wizardScreenOptionChangeNotifyProc notify);

CompListValue *  wizardGetGStrength (CompScreen *s);
CompOption *     wizardGetGStrengthOption (CompScreen *s);
void             wizardSetGStrengthNotify (CompScreen *s, wizardScreenOptionChangeNotifyProc notify);

CompListValue *  wizardGetGPosx (CompScreen *s);
CompOption *     wizardGetGPosxOption (CompScreen *s);
void             wizardSetGPosxNotify (CompScreen *s, wizardScreenOptionChangeNotifyProc notify);

CompListValue *  wizardGetGPosy (CompScreen *s);
CompOption *     wizardGetGPosyOption (CompScreen *s);
void             wizardSetGPosyNotify (CompScreen *s, wizardScreenOptionChangeNotifyProc notify);

CompListValue *  wizardGetGSpeed (CompScreen *s);
CompOption *     wizardGetGSpeedOption (CompScreen *s);
void             wizardSetGSpeedNotify (CompScreen *s, wizardScreenOptionChangeNotifyProc notify);

CompListValue *  wizardGetGAngle (CompScreen *s);
CompOption *     wizardGetGAngleOption (CompScreen *s);
void             wizardSetGAngleNotify (CompScreen *s, wizardScreenOptionChangeNotifyProc notify);

CompListValue *  wizardGetGMovement (CompScreen *s);
unsigned int     wizardGetGMovementMask (CompScreen *s);
CompOption *     wizardGetGMovementOption (CompScreen *s);
void             wizardSetGMovementNotify (CompScreen *s, wizardScreenOptionChangeNotifyProc notify);

CompListValue *  wizardGetEActive (CompScreen *s);
CompOption *     wizardGetEActiveOption (CompScreen *s);
void             wizardSetEActiveNotify (CompScreen *s, wizardScreenOptionChangeNotifyProc notify);

CompListValue *  wizardGetEName (CompScreen *s);
CompOption *     wizardGetENameOption (CompScreen *s);
void             wizardSetENameNotify (CompScreen *s, wizardScreenOptionChangeNotifyProc notify);

CompListValue *  wizardGetETrigger (CompScreen *s);
unsigned int     wizardGetETriggerMask (CompScreen *s);
CompOption *     wizardGetETriggerOption (CompScreen *s);
void             wizardSetETriggerNotify (CompScreen *s, wizardScreenOptionChangeNotifyProc notify);

CompListValue *  wizardGetEPosx (CompScreen *s);
CompOption *     wizardGetEPosxOption (CompScreen *s);
void             wizardSetEPosxNotify (CompScreen *s, wizardScreenOptionChangeNotifyProc notify);

CompListValue *  wizardGetEPosy (CompScreen *s);
CompOption *     wizardGetEPosyOption (CompScreen *s);
void             wizardSetEPosyNotify (CompScreen *s, wizardScreenOptionChangeNotifyProc notify);

CompListValue *  wizardGetESpeed (CompScreen *s);
CompOption *     wizardGetESpeedOption (CompScreen *s);
void             wizardSetESpeedNotify (CompScreen *s, wizardScreenOptionChangeNotifyProc notify);

CompListValue *  wizardGetEAngle (CompScreen *s);
CompOption *     wizardGetEAngleOption (CompScreen *s);
void             wizardSetEAngleNotify (CompScreen *s, wizardScreenOptionChangeNotifyProc notify);

CompListValue *  wizardGetEMovement (CompScreen *s);
unsigned int     wizardGetEMovementMask (CompScreen *s);
CompOption *     wizardGetEMovementOption (CompScreen *s);
void             wizardSetEMovementNotify (CompScreen *s, wizardScreenOptionChangeNotifyProc notify);

CompListValue *  wizardGetECount (CompScreen *s);
CompOption *     wizardGetECountOption (CompScreen *s);
void             wizardSetECountNotify (CompScreen *s, wizardScreenOptionChangeNotifyProc notify);

CompListValue *  wizardGetEH (CompScreen *s);
CompOption *     wizardGetEHOption (CompScreen *s);
void             wizardSetEHNotify (CompScreen *s, wizardScreenOptionChangeNotifyProc notify);

CompListValue *  wizardGetEDh (CompScreen *s);
CompOption *     wizardGetEDhOption (CompScreen *s);
void             wizardSetEDhNotify (CompScreen *s, wizardScreenOptionChangeNotifyProc notify);

CompListValue *  wizardGetEL (CompScreen *s);
CompOption *     wizardGetELOption (CompScreen *s);
void             wizardSetELNotify (CompScreen *s, wizardScreenOptionChangeNotifyProc notify);

CompListValue *  wizardGetEDl (CompScreen *s);
CompOption *     wizardGetEDlOption (CompScreen *s);
void             wizardSetEDlNotify (CompScreen *s, wizardScreenOptionChangeNotifyProc notify);

CompListValue *  wizardGetEA (CompScreen *s);
CompOption *     wizardGetEAOption (CompScreen *s);
void             wizardSetEANotify (CompScreen *s, wizardScreenOptionChangeNotifyProc notify);

CompListValue *  wizardGetEDa (CompScreen *s);
CompOption *     wizardGetEDaOption (CompScreen *s);
void             wizardSetEDaNotify (CompScreen *s, wizardScreenOptionChangeNotifyProc notify);

CompListValue *  wizardGetEDx (CompScreen *s);
CompOption *     wizardGetEDxOption (CompScreen *s);
void             wizardSetEDxNotify (CompScreen *s, wizardScreenOptionChangeNotifyProc notify);

CompListValue *  wizardGetEDy (CompScreen *s);
CompOption *     wizardGetEDyOption (CompScreen *s);
void             wizardSetEDyNotify (CompScreen *s, wizardScreenOptionChangeNotifyProc notify);

CompListValue *  wizardGetEDcirc (CompScreen *s);
CompOption *     wizardGetEDcircOption (CompScreen *s);
void             wizardSetEDcircNotify (CompScreen *s, wizardScreenOptionChangeNotifyProc notify);

CompListValue *  wizardGetEVx (CompScreen *s);
CompOption *     wizardGetEVxOption (CompScreen *s);
void             wizardSetEVxNotify (CompScreen *s, wizardScreenOptionChangeNotifyProc notify);

CompListValue *  wizardGetEVy (CompScreen *s);
CompOption *     wizardGetEVyOption (CompScreen *s);
void             wizardSetEVyNotify (CompScreen *s, wizardScreenOptionChangeNotifyProc notify);

CompListValue *  wizardGetEVt (CompScreen *s);
CompOption *     wizardGetEVtOption (CompScreen *s);
void             wizardSetEVtNotify (CompScreen *s, wizardScreenOptionChangeNotifyProc notify);

CompListValue *  wizardGetEVphi (CompScreen *s);
CompOption *     wizardGetEVphiOption (CompScreen *s);
void             wizardSetEVphiNotify (CompScreen *s, wizardScreenOptionChangeNotifyProc notify);

CompListValue *  wizardGetEDvx (CompScreen *s);
CompOption *     wizardGetEDvxOption (CompScreen *s);
void             wizardSetEDvxNotify (CompScreen *s, wizardScreenOptionChangeNotifyProc notify);

CompListValue *  wizardGetEDvy (CompScreen *s);
CompOption *     wizardGetEDvyOption (CompScreen *s);
void             wizardSetEDvyNotify (CompScreen *s, wizardScreenOptionChangeNotifyProc notify);

CompListValue *  wizardGetEDvcirc (CompScreen *s);
CompOption *     wizardGetEDvcircOption (CompScreen *s);
void             wizardSetEDvcircNotify (CompScreen *s, wizardScreenOptionChangeNotifyProc notify);

CompListValue *  wizardGetEDvt (CompScreen *s);
CompOption *     wizardGetEDvtOption (CompScreen *s);
void             wizardSetEDvtNotify (CompScreen *s, wizardScreenOptionChangeNotifyProc notify);

CompListValue *  wizardGetEDvphi (CompScreen *s);
CompOption *     wizardGetEDvphiOption (CompScreen *s);
void             wizardSetEDvphiNotify (CompScreen *s, wizardScreenOptionChangeNotifyProc notify);

CompListValue *  wizardGetES (CompScreen *s);
CompOption *     wizardGetESOption (CompScreen *s);
void             wizardSetESNotify (CompScreen *s, wizardScreenOptionChangeNotifyProc notify);

CompListValue *  wizardGetEDs (CompScreen *s);
CompOption *     wizardGetEDsOption (CompScreen *s);
void             wizardSetEDsNotify (CompScreen *s, wizardScreenOptionChangeNotifyProc notify);

CompListValue *  wizardGetESnew (CompScreen *s);
CompOption *     wizardGetESnewOption (CompScreen *s);
void             wizardSetESnewNotify (CompScreen *s, wizardScreenOptionChangeNotifyProc notify);

CompListValue *  wizardGetEDsnew (CompScreen *s);
CompOption *     wizardGetEDsnewOption (CompScreen *s);
void             wizardSetEDsnewNotify (CompScreen *s, wizardScreenOptionChangeNotifyProc notify);

CompListValue *  wizardGetEG (CompScreen *s);
CompOption *     wizardGetEGOption (CompScreen *s);
void             wizardSetEGNotify (CompScreen *s, wizardScreenOptionChangeNotifyProc notify);

CompListValue *  wizardGetEDg (CompScreen *s);
CompOption *     wizardGetEDgOption (CompScreen *s);
void             wizardSetEDgNotify (CompScreen *s, wizardScreenOptionChangeNotifyProc notify);

CompListValue *  wizardGetEGp (CompScreen *s);
CompOption *     wizardGetEGpOption (CompScreen *s);
void             wizardSetEGpNotify (CompScreen *s, wizardScreenOptionChangeNotifyProc notify);

int              wizardGetHardLimit (CompScreen *s);
CompOption *     wizardGetHardLimitOption (CompScreen *s);
void             wizardSetHardLimitNotify (CompScreen *s, wizardScreenOptionChangeNotifyProc notify);

int              wizardGetSoftLimit (CompScreen *s);
CompOption *     wizardGetSoftLimitOption (CompScreen *s);
void             wizardSetSoftLimitNotify (CompScreen *s, wizardScreenOptionChangeNotifyProc notify);

float            wizardGetDarken (CompScreen *s);
CompOption *     wizardGetDarkenOption (CompScreen *s);
void             wizardSetDarkenNotify (CompScreen *s, wizardScreenOptionChangeNotifyProc notify);

Bool             wizardGetBlend (CompScreen *s);
CompOption *     wizardGetBlendOption (CompScreen *s);
void             wizardSetBlendNotify (CompScreen *s, wizardScreenOptionChangeNotifyProc notify);

float            wizardGetTnew (CompScreen *s);
CompOption *     wizardGetTnewOption (CompScreen *s);
void             wizardSetTnewNotify (CompScreen *s, wizardScreenOptionChangeNotifyProc notify);

float            wizardGetTold (CompScreen *s);
CompOption *     wizardGetToldOption (CompScreen *s);
void             wizardSetToldNotify (CompScreen *s, wizardScreenOptionChangeNotifyProc notify);

#ifndef GENERIC_PRIVATE_DEFINES
#define GENERIC_PRIVATE_DEFINES

#define GET_PLUGIN_CORE(object, plugin) \
    ((plugin##Core *) (object)->base.privates[plugin##CorePrivateIndex].ptr)
#define PLUGIN_CORE(object, plugin, prefix) \
    plugin##Core * prefix##c = GET_PLUGIN_CORE (object, plugin)

#define GET_PLUGIN_DISPLAY(object, plugin) \
    ((plugin##Display *) \
	(object)->base.privates[plugin##DisplayPrivateIndex].ptr)
#define PLUGIN_DISPLAY(object, plugin, prefix) \
    plugin##Display * prefix##d = GET_PLUGIN_DISPLAY (object, plugin)

#define GET_PLUGIN_SCREEN(object, parent, plugin) \
    ((plugin##Screen *) \
	(object)->base.privates[(parent)->screenPrivateIndex].ptr)
#define PLUGIN_SCREEN(object, plugin, prefix) \
    plugin##Screen * prefix##s = \
	GET_PLUGIN_SCREEN (object, \
	GET_PLUGIN_DISPLAY ((object)->display, plugin), plugin)

#define GET_PLUGIN_WINDOW(object, parent, plugin) \
    ((plugin##Window *) \
	(object)->base.privates[(parent)->windowPrivateIndex].ptr)
#define PLUGIN_WINDOW(object, plugin, prefix) \
    plugin##Window * prefix##w = \
	GET_PLUGIN_WINDOW  (object, \
	GET_PLUGIN_SCREEN  ((object)->screen, \
	GET_PLUGIN_DISPLAY ((object)->screen->display, plugin), plugin), plugin)

#endif

COMPIZ_END_DECLS

#endif
